#ifdef HSMODE

#ifndef HSWRAP_H
#define HSWRAP_H
#define LOGICAL_STRICT

///////////////////////////////////
/// Higgs Signals Raw routines ////
///////////////////////////////////

/// Initialization wrapped routines
extern "C" {void initialize_higgssignals_(int & nHzero, int & nHplus, char * expdata);}
extern "C" {void initialize_higgssignals_latestresults_(int & nHzero, int & nHplus);}

extern "C" {void setup_pdf_(int & pdf);}

extern "C" {void higgssignals_neutral_input_massuncertainty_(double * dMh);}

extern "C" {void setup_rate_uncertainties_(double  dCS[5], double dBR[5]);}

extern "C" {void setup_nparam_(int & Np);}

extern "C" {void run_higgssignals_(int & mode, double & csqmu, double & csqmh, double & csqtot,int & nobs, double & Pvalue);}

extern "C" {void setup_assignmentrange_massobservables_(double & lambda);}

///Finishing wrapped routines
extern "C" {void finish_higgssignals_();}

///User specific higgssignals routines
extern "C" {void assign_toyvalue_to_peak_(int & obsID, double & mu_obs, double & mh_obs);}
extern "C" {void assign_rate_uncertainty_scalefactor_to_peak_(int & obsID, double & scale_mu);}
extern "C" {void get_id_of_peakobservable_(int & i, int & obsID);}
extern "C" {void get_number_of_observables_(int & ntotal, int & npeakmu, int & npeakmh, int &  nmpred, int & nanalyses);}
extern "C" {void get_peakinfo_from_hsresults_(int & obsID, double * mupred,int * domH, int* nHcomb);}
extern "C" {void get_pvalue_(int & Np, double & Pvalue);}
extern "C" {void get_rates_(int & i, int & collider, int & Nchannels, int * IDchannels,double & rate);}
extern "C" {void get_rvalues_(int & i, int & collider, double & R_H_WW, double & R_H_ZZ,double & R_H_gaga, double & R_H_tautau, double & R_H_bb,double & R_VH_bb);}
extern "C" {void higgssignals_create_slha_output_(char* filename, int & detailed);}
extern "C" {void higgssignals_create_slha_output_default_(int & detailed);}
extern "C" {void higgssignals_slha_output_(int & detailed);}
extern "C" {void setup_assignmentrange_(double & Lambda);}
extern "C" {void setup_correlations_(int & corr_mu, int & corr_mh);}
extern "C" {void setup_mcmethod_dm_theory_(int & mode);}
extern "C" {void setup_output_level_(int & level);}


#endif

#endif
