#ifdef HDECAYMODE

#ifndef HDECAYWRAP_H
#define HDECAYWRAP_H

#include <fstream>
#include <iostream>
#include <cmath>
#include <iomanip>
#include <map>
#include <string>


extern "C" { void hdecaycall2hdm_(double & ABRB_out,double & ABRL_out,double & ABRM_out,double & ABRS_out,double & ABRC_out,double & ABRT_out,double & ABRG_out,double & ABRGA_out,double &  ABRZGA_out,double & ABRZ_out,double & AWDTH_out,double & HLBRB_out,double & HLBRL_out,double & HLBRM_out,double & HLBRS_out,double & HLBRC_out,double & HLBRT_out,double & HLBRG_out,double & HLBRGA_out,double & HLBRZGA_out,double & HLBRW_out,double & HLBRZ_out,double & HLBRA_out,double & HLBRAZ_out,double & HLBRHW_out,double & HLWDTH_out,double & HHBRB_out,double & HHBRL_out,double & HHBRM_out,double & HHBRS_out,double & HHBRC_out,double & HHBRT_out,double & HHBRG_out,double & HHBRGA_out,double & HHBRZGA_out,double & HHBRW_out,double & HHBRZ_out,double & HHBRH_out,double & HHBRA_out,double & HHBRAZ_out,double & HHBRHW_out,double & HHWDTH_out,double & HCBRB_out,double & HCBRL_out,double & HCBRM_out,double & HCBRBU_out,double & HCBRS_out,double & HCBRC_out,double & HCBRT_out,double & HCBRW_out,double & HCBRA_out,double & HCWDTH_out, double & hcbrcd_out,double & hcbrts_out,double & hcbrtd,double & hcbrwhh_out,double & hhbrchch_out,double & hlbrchch_out,double & abrhhaz_out,double & abrhawphm_out, double & gamt0, double & gamt1);}

extern "C" { void  hdecaycallsm_(double & SMBRB_out,double & SMBRL_out,double & SMBRM_out,double & SMBRS_out,double & SMBRC_out,double & SMBRT_out,double & SMBRG_out,double & SMBRGA_out,double & SMBRZGA_out,double &  SMBRW_out,double & SMBRZ_out,double & SMWDTH_out);}

extern "C" { void  hdecaycallsinglets_(double & SING1_BRB_out,double & SING1_BRL_out,double & SING1_BRM_out,double & SING1_BRS_out,double & SING1_BRC_out,double & SING1_BRT_out,double & SING1_BRG_out,double & SING1_BRGA_out,double & SING1_BRZGA_out,double & SING1_BRW_out,double & SING1_BRZ_out,double & SING1_WDTH_out,double & SING2_BRB_out,double & SING2_BRL_out,double & SING2_BRM_out,double & SING2_BRS_out,double & SING2_BRC_out,double & SING2_BRT_out,double & SING2_BRG_out,double & SING2_BRGA_out,double & SING2_BRZGA_out,double & SING2_BRW_out,double & SING2_BRZ_out,double & SING2_WDTH_out,double & SING3_BRB_out,double & SING3_BRL_out,double & SING3_BRM_out,double & SING3_BRS_out,double & SING3_BRC_out,double & SING3_BRT_out,double & SING3_BRG_out,double & SING3_BRGA_out,double & SING3_BRZGA_out,double & SING3_BRW_out,double & SING3_BRZ_out,double & SING3_WDTH_out,double & SING_BRH1H2H2_out,double & SING_BRH1H3H3_out,double & SING_BRH1H2H3_out,double & SING_BRH2H1H1_out,double & SING_BRH2H3H3_out,double & SING_BRH2H1H3_out,double & SING_BRH3H1H1_out,double & SING_BRH3H2H2_out,double & SING_BRH3H1H2_out);}

extern "C" { void  hdecaycallplain_(double & );}

extern "C" { void hdecaycalln2hdm_(double H1_val[],double H2_val[],double H3_val[],double A_val[],double HC_val[],double TOP_val[]);}

extern "C" { void hdecaycallc2hdm_(double H1_val[],double H2_val[],double H3_val[],double HC_val[],double TOP_val[]);}

void CreateInputFileHdecay2HDM(int Type, double tanbeta,double alpha, double mHlight,double mHheavy, double mA, double mCharged,double m12sq);
void CreateInputFileHdecaySM(double mH);
void HdecayCalc2HDM(std::map<std::string,double> & HdecayA,std::map<std::string,double> & HdecayHlight,std::map<std::string,double> & HdecayHheavy,std::map<std::string,double> & HdecayHcharged,std::map<std::string,double> & HdecayTop);
void HdecayCalcSM(std::map<std::string,double> & HdecayHsm);

void HdecayCalcN2HDM(std::map<std::string,double> & HdecayA,std::map<std::string,double> & HdecayHh,std::map<std::string,double> & HdecayHH,std::map<std::string,double> & HdecayHS,std::map<std::string,double> & HdecayHc,std::map<std::string,double> & HdecayTop);
void CreateInputFileHdecayN2HDM(int Type, double tanbeta, double alpha, double gamma, double delta, double mHh,double mHH, double mHS, double mA, double mHc, double m12sq, double vevs);

void HdecayCalcC2HDM(std::map<std::string,double> & Hdecay);
void CreateInputFileHdecayC2HDM(int Type, double tanbeta, double a1, double a2, double a3, double mH1, double mH2, double mHc, double re_m12sq);
void CreateInputFileHdecayRsinglet(double mH1,double mH2,double alpha1,double vs,double m2s,double lambdas,int type);
void CreateInputFileHdecayCsinglet(double mH1,double mH2,double mH3,double alph1,double alph2,double alph3,double vs,double a1,int type);
void HdecayCalcSing(std::map<std::string,double> & HdecayHsm);

void HdecayCalc(void);

#endif

#endif
