#include "MOmegasWrap.h"

using namespace std;

bool test_nucleon_amplitudes(double & Omega,double & sigmaSI3,double DM_mass,double * pA0,double * pAspin,double * nA0,double * nAspin){
  
  double SCcoeff;   
  double err1=nucleonAmplitudes(NULL,pA0,pAspin,nA0,nAspin);
  //clog <<"err1="<<err1<< endl;
  //// For verbose mode..
  SCcoeff=4/M_PI*3.8937966E8*pow(nucleonMass*Mcdm/(nucleonMass+ Mcdm),2.); // Value given by micromegas
  sigmaSI3=SCcoeff*pA0[0]*pA0[0];
  if(DM_mass>=exp(1.7) && DM_mass<=exp(8.5)){
    double sigmaup=Interp(log(DM_mass),LUX2013);
    if(sigmaSI3*Omega/0.112>sigmaup)
      return false;
  }

  return true;
}

bool test_nucleon_amplitudes(double & Omega,double & sigmaSI3,double DM_mass,double spin_amplitudes[4][2], double & sigmaup){
  
  double SCcoeff;   
  double err1=nucleonAmplitudes(NULL,spin_amplitudes[0],spin_amplitudes[1],spin_amplitudes[2],spin_amplitudes[3]);
  //clog <<"err1="<<err1<< endl;
  //// For verbose mode..
  SCcoeff=4/M_PI*3.8937966E8*pow(nucleonMass*Mcdm/(nucleonMass+ Mcdm),2.); // Value given by micromegas
  sigmaSI3=SCcoeff*spin_amplitudes[0][0]*spin_amplitudes[0][0];
  if(DM_mass>=exp(1.7) && DM_mass<=exp(8.5)){
    sigmaup=Interp(log(DM_mass),LUX2013);
    if(sigmaSI3*Omega/0.112>sigmaup)
      return false;
  }

  return true;
}
