#ifndef SCANNERSTABLES_H
#define SCANNERSTABLES_H 
#include<vector>
#include "ScannerSAnalysisUtils.h"

//////////// CROSS SECTIONS

//// NNLO QCD calculations with SusHi

///////////////////
//// GG FUSION ////
///// Form functions without higher order electroweak corrections for the LHC and Tevatron

// TT form factor
extern TableData TableSusHi_ggF_TTfunc_H_CPeven_noEW_mrange30_330Ecm7_14pp;
extern TableData TableSusHi_ggF_TTfunc_H_CPeven_noEW_mrange330_360Ecm7_14pp;
extern TableData TableSusHi_ggF_TTfunc_H_CPeven_noEW_mrange360_1000Ecm7_14pp;
//
extern TableData TableSusHi_ggF_TTfunc_H_CPeven_noEW_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_TTfunc_H_CPeven_noEW_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_TTfunc_H_CPeven_noEW_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHi_ggF_TTfunc_H_CPeven_noEW_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHi_ggF_TTfunc_H_CPeven_noEW_mrange360_1000Ecm1_5_2ppbar;
//
extern TableData TableSusHi_ggF_TTfunc_H_CPodd_noEW_mrange30_330Ecm7_14pp;
extern TableData TableSusHi_ggF_TTfunc_H_CPodd_noEW_mrange330_360Ecm7_14pp;
extern TableData TableSusHi_ggF_TTfunc_H_CPodd_noEW_mrange360_1000Ecm7_14pp;
//
extern TableData TableSusHi_ggF_TTfunc_H_CPodd_noEW_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_TTfunc_H_CPodd_noEW_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_TTfunc_H_CPodd_noEW_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHi_ggF_TTfunc_H_CPodd_noEW_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHi_ggF_TTfunc_H_CPodd_noEW_mrange360_1000Ecm1_5_2ppbar;

// TB form factor
extern TableData TableSusHi_ggF_TBfunc_H_CPeven_noEW_mrange30_330Ecm7_14pp;
extern TableData TableSusHi_ggF_TBfunc_H_CPeven_noEW_mrange330_360Ecm7_14pp;
extern TableData TableSusHi_ggF_TBfunc_H_CPeven_noEW_mrange360_1000Ecm7_14pp;
//
extern TableData TableSusHi_ggF_TBfunc_H_CPeven_noEW_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_TBfunc_H_CPeven_noEW_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_TBfunc_H_CPeven_noEW_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHi_ggF_TBfunc_H_CPeven_noEW_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHi_ggF_TBfunc_H_CPeven_noEW_mrange360_1000Ecm1_5_2ppbar;
//
extern TableData TableSusHi_ggF_TBfunc_H_CPodd_noEW_mrange30_330Ecm7_14pp;
extern TableData TableSusHi_ggF_TBfunc_H_CPodd_noEW_mrange330_360Ecm7_14pp;
extern TableData TableSusHi_ggF_TBfunc_H_CPodd_noEW_mrange360_1000Ecm7_14pp;
//
extern TableData TableSusHi_ggF_TBfunc_H_CPodd_noEW_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_TBfunc_H_CPodd_noEW_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_TBfunc_H_CPodd_noEW_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHi_ggF_TBfunc_H_CPodd_noEW_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHi_ggF_TBfunc_H_CPodd_noEW_mrange360_1000Ecm1_5_2ppbar;

// BB form factor
extern TableData TableSusHi_ggF_BBfunc_H_CPeven_noEW_mrange30_330Ecm7_14pp;
extern TableData TableSusHi_ggF_BBfunc_H_CPeven_noEW_mrange330_360Ecm7_14pp;
extern TableData TableSusHi_ggF_BBfunc_H_CPeven_noEW_mrange360_1000Ecm7_14pp;
//
extern TableData TableSusHi_ggF_BBfunc_H_CPeven_noEW_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_BBfunc_H_CPeven_noEW_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_BBfunc_H_CPeven_noEW_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHi_ggF_BBfunc_H_CPeven_noEW_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHi_ggF_BBfunc_H_CPeven_noEW_mrange360_1000Ecm1_5_2ppbar;
//
extern TableData TableSusHi_ggF_BBfunc_H_CPodd_noEW_mrange30_330Ecm7_14pp;
extern TableData TableSusHi_ggF_BBfunc_H_CPodd_noEW_mrange330_360Ecm7_14pp;
extern TableData TableSusHi_ggF_BBfunc_H_CPodd_noEW_mrange360_1000Ecm7_14pp;
//
extern TableData TableSusHi_ggF_BBfunc_H_CPodd_noEW_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_BBfunc_H_CPodd_noEW_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHi_ggF_BBfunc_H_CPodd_noEW_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHi_ggF_BBfunc_H_CPodd_noEW_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHi_ggF_BBfunc_H_CPodd_noEW_mrange360_1000Ecm1_5_2ppbar;


///////////////////
//// BB FUSION ////
///// Form functions without higher order electroweak corrections for the LHC and Tevatron

// BB form factor (This is the only non-zero one here!)
extern TableData TableSusHi_bbF_BBfunc_H_CPeven_noEW_mrange30_330Ecm7_14pp;
extern TableData TableSusHi_bbF_BBfunc_H_CPeven_noEW_mrange330_360Ecm7_14pp;
extern TableData TableSusHi_bbF_BBfunc_H_CPeven_noEW_mrange360_1000Ecm7_14pp;
//
extern TableData TableSusHi_bbF_BBfunc_H_CPeven_noEW_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHi_bbF_BBfunc_H_CPeven_noEW_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHi_bbF_BBfunc_H_CPeven_noEW_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHi_bbF_BBfunc_H_CPeven_noEW_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHi_bbF_BBfunc_H_CPeven_noEW_mrange360_1000Ecm1_5_2ppbar;
//
extern TableData TableSusHi_bbF_BBfunc_H_CPodd_noEW_mrange30_330Ecm7_14pp;
extern TableData TableSusHi_bbF_BBfunc_H_CPodd_noEW_mrange330_360Ecm7_14pp;
extern TableData TableSusHi_bbF_BBfunc_H_CPodd_noEW_mrange360_1000Ecm7_14pp;
//
extern TableData TableSusHi_bbF_BBfunc_H_CPodd_noEW_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHi_bbF_BBfunc_H_CPodd_noEW_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHi_bbF_BBfunc_H_CPodd_noEW_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHi_bbF_BBfunc_H_CPodd_noEW_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHi_bbF_BBfunc_H_CPodd_noEW_mrange360_1000Ecm1_5_2ppbar;

void Load_ggF_bbF_noEW_SusHiPP_PPbarTables_LHC_plus_Tevatron(void);
double InternalTableSusHiPP_ggF_noEW(double Ecm, double mH, int CP,double gHtt_rel_SM, double gHbb_rel_SM);
double InternalTableSusHiPP_bbF_noEW(double Ecm, double mH, int CP,double gHbb_rel_SM);
double InternalTableSusHiPPbar_ggF_noEW(double Ecm, double mH, int CP,double gHtt_rel_SM, double gHbb_rel_SM);
double InternalTableSusHiPPbar_bbF_noEW(double Ecm, double mH, int CP,double gHbb_rel_SM);

/////////////////

extern TableData TableSusHi_SM_noEW_mrange30_330Ecm7_14pp;
extern TableData TableSusHi_SM_noEW_mrange330_360Ecm7_14pp;
extern TableData TableSusHi_SM_noEW_mrange360_1000Ecm7_14pp;

void Load_SM_noEW_SusHiPP_7to14(void);
double InternalTableSusHiPP_SM_noEW(double Ecm, double mH);

///// SM Higgs cross sections (in pb) at the LHC tables at 7 TeV as a function of mH in steps of 1 GeV (extracted from https://twiki.cern.ch/twiki/bin/view/LHCPhysics/CERNYellowReportPageAt7TeV)

//SM Higgs ggF 
const double sigmaLHCHiggsggF7TeV[924]={921, 80, 1000, 36.5934, 35.7127, 34.8635, 34.0445, 33.2548, 32.491, 31.7537, 31.041, 30.3516, 29.685, 29.0315, 28.4156, 27.8111, 27.2254, 26.6478, 26.098, 25.565, 25.0574, 24.5552, 24.0677, 23.6362, 23.1746, 22.7254, 22.289, 21.8662, 21.4527, 21.0533, 20.6661, 20.2872, 19.9164, 19.5571, 19.2062, 18.8654, 18.5337, 18.2099, 17.8946, 17.5867, 17.2867, 16.994, 16.7084, 16.4295, 16.1577, 15.8919, 15.6329, 15.3798, 15.1326, 14.8909, 14.6547, 14.424, 14.1983, 13.9776, 13.7625, 13.5519, 13.3462, 13.1446, 12.9473, 12.7542, 12.5651, 12.3801, 12.1988, 12.0212, 11.8913, 11.7263, 11.5632, 11.4027, 11.2446, 11.0909, 10.9437, 10.7961, 10.6514, 10.508, 10.3737, 10.2393, 10.1089, 9.9784, 9.8507, 9.723, 9.59785, 9.4727, 9.348, 9.2233, 9.0766, 8.9299, 8.75775, 8.5856, 8.4342, 8.2924, 8.1607, 8.029, 7.91485, 7.8007, 7.6928, 7.5849, 7.48505, 7.3852, 7.291, 7.1988, 7.11255, 7.0263, 6.9409, 6.8555, 6.76625, 6.677, 6.5771, 6.4772, 6.3836, 6.2915, 6.2076, 6.1237, 6.04715, 5.9706, 5.89695, 5.8233, 5.7536, 5.6839, 5.614, 5.5468, 5.4939, 5.441, 5.3986, 5.3562, 5.29925, 5.2423, 5.20575, 5.1692, 5.1235, 5.0778, 5.03, 4.9822, 4.9386, 4.895, 4.8505, 4.806, 4.7685, 4.731, 4.6995, 4.668, 4.62465, 4.5813, 4.5416, 4.5019, 4.4631, 4.4243, 4.39085, 4.3574, 4.32825, 4.2991, 4.26155, 4.224, 4.1903, 4.1566, 4.1253, 4.094, 4.06495, 4.0359, 4.00325, 3.9706, 3.93725, 3.9039, 3.86945, 3.835, 3.8031, 3.7712, 3.7402, 3.7092, 3.68, 3.6508, 3.6233, 3.5958, 3.5678, 3.5398, 3.5131, 3.4864, 3.46015, 3.4339, 3.40865, 3.3834, 3.3593, 3.3352, 3.31175, 3.2883, 3.26555, 3.2428, 3.2208, 3.1988, 3.17685, 3.1549, 3.1338, 3.1127, 3.0922, 3.0717, 3.0524, 3.0331, 3.0143, 2.9955, 2.97735, 2.9592, 2.94135, 2.9235, 2.9064, 2.8893, 2.87275, 2.8562, 2.8401, 2.824, 2.8088, 2.7936, 2.77885, 2.7641, 2.7498, 2.7355, 2.7217, 2.7079, 2.6946, 2.6813, 2.6685, 2.6557, 2.64365, 2.6316, 2.61985, 2.6081, 2.59754, 2.58698, 2.57642, 2.56586, 2.5553, 2.54614, 2.53698, 2.52782, 2.51866, 2.5095, 2.50168, 2.49386, 2.48604, 2.47822, 2.4704, 2.46348, 2.45656, 2.44964, 2.44272, 2.4358, 2.43092, 2.42604, 2.42116, 2.41628, 2.4114, 2.4085, 2.4056, 2.4027, 2.3998, 2.3969, 2.396, 2.3951, 2.3942, 2.3933, 2.3924, 2.39422, 2.39604, 2.39786, 2.39968, 2.4015, 2.40632, 2.41114, 2.41596, 2.42078, 2.4256, 2.42508, 2.42456, 2.42404, 2.42352, 2.423, 2.42108, 2.41916, 2.41724, 2.41532, 2.4134, 2.41148, 2.40956, 2.40764, 2.40572, 2.4038, 2.39929, 2.39478, 2.39027, 2.38576, 2.38125, 2.37674, 2.37223, 2.36772, 2.36321, 2.3587, 2.35079, 2.34288, 2.33497, 2.32706, 2.31915, 2.31124, 2.30333, 2.29542, 2.28751, 2.2796, 2.26887, 2.25814, 2.24741, 2.23668, 2.22595, 2.21522, 2.20449, 2.19376, 2.18303, 2.1723, 2.15975, 2.1472, 2.13465, 2.1221, 2.10955, 2.097, 2.08445, 2.0719, 2.05935, 2.0468, 2.0332, 2.01959, 2.00599, 1.99238, 1.97878, 1.96517, 1.95157, 1.93796, 1.92436, 1.91075, 1.89715, 1.88354, 1.86994, 1.85633, 1.84273, 1.82912, 1.81552, 1.80191, 1.78831, 1.7747, 1.76128, 1.74786, 1.73444, 1.72102, 1.7076, 1.69418, 1.68076, 1.66734, 1.65392, 1.6405, 1.62708, 1.61366, 1.60024, 1.58682, 1.5734, 1.55998, 1.54656, 1.53314, 1.51972, 1.5063, 1.4937, 1.4811, 1.4685, 1.4559, 1.4433, 1.4307, 1.4181, 1.4055, 1.3929, 1.3803, 1.36846, 1.35662, 1.34478, 1.33294, 1.3211, 1.30926, 1.29742, 1.28558, 1.27374, 1.2619, 1.2513, 1.24069, 1.23009, 1.21948, 1.20888, 1.19827, 1.18767, 1.17706, 1.16646, 1.15585, 1.14525, 1.13464, 1.12404, 1.11343, 1.10283, 1.09222, 1.08162, 1.07101, 1.06041, 1.0498, 1.04083, 1.03186, 1.02289, 1.01392, 1.00495, 0.99598, 0.98701, 0.97804, 0.96907, 0.9601, 0.95113, 0.94216, 0.93319, 0.92422, 0.91525, 0.90628, 0.89731, 0.88834, 0.87937, 0.8704, 0.86292, 0.85544, 0.84796, 0.84048, 0.833, 0.82552, 0.81804, 0.81056, 0.80308, 0.7956, 0.78812, 0.78064, 0.77316, 0.76568, 0.7582, 0.75072, 0.74324, 0.73576, 0.72828, 0.7208, 0.71463, 0.70846, 0.70229, 0.69612, 0.68995, 0.68378, 0.67761, 0.67144, 0.66527, 0.6591, 0.65293, 0.64676, 0.64059, 0.63442, 0.62825, 0.62208, 0.61591, 0.60974, 0.60357, 0.5974, 0.59207, 0.58674, 0.58141, 0.57608, 0.57075, 0.56542, 0.56009, 0.55476, 0.54943, 0.5441, 0.53927, 0.53444, 0.52961, 0.52478, 0.51995, 0.51512, 0.51029, 0.50546, 0.50063, 0.4958, 0.49164, 0.48748, 0.48332, 0.47916, 0.475, 0.47084, 0.46668, 0.46252, 0.45836, 0.4542, 0.45004, 0.44588, 0.44172, 0.43756, 0.4334, 0.42924, 0.42508, 0.42092, 0.41676, 0.4126, 0.409195, 0.40579, 0.402385, 0.39898, 0.395575, 0.39217, 0.388765, 0.38536, 0.381955, 0.37855, 0.375145, 0.37174, 0.368335, 0.36493, 0.361525, 0.35812, 0.354715, 0.35131, 0.347905, 0.3445, 0.341695, 0.33889, 0.336085, 0.33328, 0.330475, 0.32767, 0.324865, 0.32206, 0.319255, 0.31645, 0.313645, 0.31084, 0.308035, 0.30523, 0.302425, 0.29962, 0.296815, 0.29401, 0.291205, 0.2884, 0.28609, 0.28378, 0.28147, 0.27916, 0.27685, 0.27454, 0.27223, 0.26992, 0.26761, 0.2653, 0.26299, 0.26068, 0.25837, 0.25606, 0.25375, 0.25144, 0.24913, 0.24682, 0.24451, 0.2422, 0.24022, 0.23824, 0.23626, 0.23428, 0.2323, 0.23032, 0.22834, 0.22636, 0.22438, 0.2224, 0.22059, 0.21878, 0.21697, 0.21516, 0.21335, 0.21154, 0.20973, 0.20792, 0.20611, 0.2043, 0.20273, 0.20116, 0.19959, 0.19802, 0.19645, 0.19488, 0.19331, 0.19174, 0.19017, 0.1886, 0.18703, 0.18546, 0.18389, 0.18232, 0.18075, 0.17918, 0.17761, 0.17604, 0.17447, 0.1729, 0.1716, 0.1703, 0.169, 0.1677, 0.1664, 0.1651, 0.1638, 0.1625, 0.1612, 0.1599, 0.1586, 0.1573, 0.156, 0.1547, 0.1534, 0.1521, 0.1508, 0.1495, 0.1482, 0.1469, 0.14582, 0.14474, 0.14366, 0.14258, 0.1415, 0.14042, 0.13934, 0.13826, 0.13718, 0.1361, 0.13502, 0.13394, 0.13286, 0.13178, 0.1307, 0.12962, 0.12854, 0.12746, 0.12638, 0.1253, 0.124395, 0.12349, 0.122585, 0.12168, 0.120775, 0.11987, 0.118965, 0.11806, 0.117155, 0.11625, 0.115345, 0.11444, 0.113535, 0.11263, 0.111725, 0.11082, 0.109915, 0.10901, 0.108105, 0.1072, 0.10641, 0.10562, 0.10483, 0.10404, 0.10325, 0.10246, 0.10167, 0.10088, 0.10009, 0.0993, 0.09857, 0.09784, 0.09711, 0.09638, 0.09565, 0.09492, 0.09419, 0.09346, 0.09273, 0.092, 0.09137, 0.09074, 0.09011, 0.08948, 0.08885, 0.08822, 0.08759, 0.08696, 0.08633, 0.0857, 0.08507, 0.08444, 0.08381, 0.08318, 0.08255, 0.08192, 0.08129, 0.08066, 0.08003, 0.0794, 0.078865, 0.07833, 0.077795, 0.07726, 0.076725, 0.07619, 0.075655, 0.07512, 0.074585, 0.07405, 0.073515, 0.07298, 0.072445, 0.07191, 0.071375, 0.07084, 0.070305, 0.06977, 0.069235, 0.0687, 0.068245, 0.06779, 0.067335, 0.06688, 0.066425, 0.06597, 0.065515, 0.06506, 0.064605, 0.06415, 0.063695, 0.06324, 0.062785, 0.06233, 0.061875, 0.06142, 0.060965, 0.06051, 0.060055, 0.0596, 0.059215, 0.05883, 0.058445, 0.05806, 0.057675, 0.05729, 0.056905, 0.05652, 0.056135, 0.05575, 0.055365, 0.05498, 0.054595, 0.05421, 0.053825, 0.05344, 0.053055, 0.05267, 0.052285, 0.0519, 0.05156, 0.05122, 0.05088, 0.05054, 0.0502, 0.04986, 0.04952, 0.04918, 0.04884, 0.0485, 0.04819, 0.04788, 0.04757, 0.04726, 0.04695, 0.04664, 0.04633, 0.04602, 0.04571, 0.0454, 0.04512, 0.04484, 0.04456, 0.04428, 0.044, 0.04372, 0.04344, 0.04316, 0.04288, 0.0426, 0.04232, 0.04204, 0.04176, 0.04148, 0.0412, 0.04092, 0.04064, 0.04036, 0.04008, 0.0398, 0.03956, 0.03932, 0.03908, 0.03884, 0.0386, 0.03836, 0.03812, 0.03788, 0.03764, 0.0374, 0.03716, 0.03692, 0.03668, 0.03644, 0.0362, 0.03596, 0.03572, 0.03548, 0.03524, 0.035, 0.034795, 0.03459, 0.034385, 0.03418, 0.033975, 0.03377, 0.033565, 0.03336, 0.033155, 0.03295, 0.032745, 0.03254, 0.032335, 0.03213, 0.031925, 0.03172, 0.031515, 0.03131, 0.031105, 0.0309, 0.03072, 0.03054, 0.03036, 0.03018, 0.03, 0.02982, 0.02964, 0.02946, 0.02928, 0.0291, 0.02892, 0.02874, 0.02856, 0.02838, 0.0282, 0.02802, 0.02784, 0.02766, 0.02748, 0.0273, 0.02714, 0.02698, 0.02682, 0.02666, 0.0265, 0.02634, 0.02618, 0.02602, 0.02586, 0.0257, 0.02555, 0.0254, 0.02525, 0.0251, 0.02495, 0.0248, 0.02465, 0.0245, 0.02435, 0.0242, 0.02407, 0.02394, 0.02381, 0.02368, 0.02355, 0.02342, 0.02329, 0.02316, 0.02303, 0.0229, 0.02277, 0.02264, 0.02251, 0.02238, 0.02225, 0.02212, 0.02199, 0.02186, 0.02173, 0.0216, 0.02148, 0.02136, 0.02124, 0.02112, 0.021, 0.02088, 0.02076, 0.02064, 0.02052, 0.0204, 0.02028, 0.02016, 0.02004, 0.01992, 0.0198, 0.01968, 0.01956, 0.01944, 0.01932, 0.0192};

//SM Higgs VBF
const double sigmaLHCHiggsVBF7TeV[924]={921, 80, 1000, 1.914, 1.894, 1.871, 1.853, 1.833, 1.814, 1.794, 1.776, 1.759, 1.738, 1.723, 1.705, 1.689, 1.668, 1.654, 1.639, 1.617, 1.6, 1.582, 1.568, 1.557, 1.541, 1.526, 1.509, 1.492, 1.478, 1.465, 1.452, 1.438, 1.423, 1.41, 1.396, 1.382, 1.369, 1.356, 1.344, 1.33, 1.317, 1.304, 1.292, 1.279, 1.269, 1.257, 1.246, 1.234, 1.222, 1.211, 1.199, 1.187, 1.178, 1.168, 1.157, 1.147, 1.136, 1.127, 1.117, 1.107, 1.097, 1.087, 1.078, 1.069, 1.059, 1.05, 1.04, 1.032, 1.023, 1.015, 1.005, 0.998, 0.988, 0.98, 0.972, 0.964, 0.95635, 0.9487, 0.9413, 0.9339, 0.9269, 0.9199, 0.9121, 0.9043, 0.89745, 0.8906, 0.88305, 0.8755, 0.8694, 0.8613, 0.8543, 0.8473, 0.84055, 0.8338, 0.82695, 0.8201, 0.8132, 0.8063, 0.7998, 0.7934, 0.78715, 0.7809, 0.77465, 0.7684, 0.76225, 0.7561, 0.7497, 0.7433, 0.7375, 0.7314, 0.72545, 0.7195, 0.71375, 0.708, 0.702, 0.696, 0.69025, 0.6845, 0.679, 0.6735, 0.6682, 0.6629, 0.65765, 0.6524, 0.64765, 0.6429, 0.6386, 0.6343, 0.63025, 0.6262, 0.6223, 0.6184, 0.6146, 0.6108, 0.60705, 0.6033, 0.5994, 0.5955, 0.5917, 0.5879, 0.58405, 0.5802, 0.5763, 0.5724, 0.5685, 0.5646, 0.5608, 0.557, 0.55315, 0.5493, 0.54545, 0.5416, 0.53785, 0.5341, 0.53035, 0.5266, 0.5228, 0.519, 0.5152, 0.5114, 0.5076, 0.5038, 0.49985, 0.4959, 0.49205, 0.4882, 0.48445, 0.4807, 0.477, 0.4733, 0.4696, 0.4659, 0.46235, 0.4588, 0.45535, 0.4519, 0.44855, 0.4452, 0.44185, 0.4385, 0.43525, 0.432, 0.4288, 0.4256, 0.42245, 0.4193, 0.4162, 0.4131, 0.41, 0.4069, 0.40395, 0.401, 0.39805, 0.3951, 0.39225, 0.3894, 0.38655, 0.3837, 0.381, 0.3783, 0.3756, 0.3729, 0.37025, 0.3676, 0.36495, 0.3623, 0.35975, 0.3572, 0.35465, 0.3521, 0.3496, 0.3471, 0.34465, 0.3422, 0.3415, 0.3408, 0.3401, 0.3394, 0.33865, 0.3379, 0.3372, 0.3365, 0.33575, 0.335, 0.33274, 0.33048, 0.32822, 0.32596, 0.3237, 0.32156, 0.31942, 0.31728, 0.31514, 0.313, 0.31096, 0.30892, 0.30688, 0.30484, 0.3028, 0.30082, 0.29884, 0.29686, 0.29488, 0.2929, 0.291, 0.2891, 0.2872, 0.2853, 0.2834, 0.28162, 0.27984, 0.27806, 0.27628, 0.2745, 0.27282, 0.27114, 0.26946, 0.26778, 0.2661, 0.26458, 0.26306, 0.26154, 0.26002, 0.2585, 0.25718, 0.25586, 0.25454, 0.25322, 0.2519, 0.24912, 0.24634, 0.24356, 0.24078, 0.238, 0.23562, 0.23324, 0.23086, 0.22848, 0.2261, 0.22372, 0.22134, 0.21896, 0.21658, 0.2142, 0.21317, 0.21214, 0.21111, 0.21008, 0.20905, 0.20802, 0.20699, 0.20596, 0.20493, 0.2039, 0.203, 0.2021, 0.2012, 0.2003, 0.1994, 0.1985, 0.1976, 0.1967, 0.1958, 0.1949, 0.194, 0.1931, 0.1922, 0.1913, 0.1904, 0.1895, 0.1886, 0.1877, 0.1868, 0.1859, 0.18503, 0.18416, 0.18329, 0.18242, 0.18155, 0.18068, 0.17981, 0.17894, 0.17807, 0.1772, 0.176345, 0.17549, 0.174635, 0.17378, 0.172925, 0.17207, 0.171215, 0.17036, 0.169505, 0.16865, 0.167795, 0.16694, 0.166085, 0.16523, 0.164375, 0.16352, 0.162665, 0.16181, 0.160955, 0.1601, 0.159305, 0.15851, 0.157715, 0.15692, 0.156125, 0.15533, 0.154535, 0.15374, 0.152945, 0.15215, 0.151355, 0.15056, 0.149765, 0.14897, 0.148175, 0.14738, 0.146585, 0.14579, 0.144995, 0.1442, 0.14346, 0.14272, 0.14198, 0.14124, 0.1405, 0.13976, 0.13902, 0.13828, 0.13754, 0.1368, 0.13608, 0.13536, 0.13464, 0.13392, 0.1332, 0.13248, 0.13176, 0.13104, 0.13032, 0.1296, 0.12894, 0.12828, 0.12762, 0.12696, 0.1263, 0.12564, 0.12498, 0.12432, 0.12366, 0.123, 0.12234, 0.12168, 0.12102, 0.12036, 0.1197, 0.11904, 0.11838, 0.11772, 0.11706, 0.1164, 0.11581, 0.11522, 0.11463, 0.11404, 0.11345, 0.11286, 0.11227, 0.11168, 0.11109, 0.1105, 0.10991, 0.10932, 0.10873, 0.10814, 0.10755, 0.10696, 0.10637, 0.10578, 0.10519, 0.1046, 0.10407, 0.10354, 0.10301, 0.10248, 0.10195, 0.10142, 0.10089, 0.10036, 0.09983, 0.0993, 0.09877, 0.09824, 0.09771, 0.09718, 0.09665, 0.09612, 0.09559, 0.09506, 0.09453, 0.094, 0.09353, 0.09306, 0.09259, 0.09212, 0.09165, 0.09118, 0.09071, 0.09024, 0.08977, 0.0893, 0.08883, 0.08836, 0.08789, 0.08742, 0.08695, 0.08648, 0.08601, 0.08554, 0.08507, 0.0846, 0.08417, 0.08374, 0.08331, 0.08288, 0.08245, 0.08202, 0.08159, 0.08116, 0.08073, 0.0803, 0.0799, 0.0795, 0.0791, 0.0787, 0.0783, 0.0779, 0.0775, 0.0771, 0.0767, 0.0763, 0.07593, 0.07556, 0.07519, 0.07482, 0.07445, 0.07408, 0.07371, 0.07334, 0.07297, 0.0726, 0.07223, 0.07186, 0.07149, 0.07112, 0.07075, 0.07038, 0.07001, 0.06964, 0.06927, 0.0689, 0.068575, 0.06825, 0.067925, 0.0676, 0.067275, 0.06695, 0.066625, 0.0663, 0.065975, 0.06565, 0.065325, 0.065, 0.064675, 0.06435, 0.064025, 0.0637, 0.063375, 0.06305, 0.062725, 0.0624, 0.062115, 0.06183, 0.061545, 0.06126, 0.060975, 0.06069, 0.060405, 0.06012, 0.059835, 0.05955, 0.059265, 0.05898, 0.058695, 0.05841, 0.058125, 0.05784, 0.057555, 0.05727, 0.056985, 0.0567, 0.05644, 0.05618, 0.05592, 0.05566, 0.0554, 0.05514, 0.05488, 0.05462, 0.05436, 0.0541, 0.05384, 0.05358, 0.05332, 0.05306, 0.0528, 0.05254, 0.05228, 0.05202, 0.05176, 0.0515, 0.05127, 0.05104, 0.05081, 0.05058, 0.05035, 0.05012, 0.04989, 0.04966, 0.04943, 0.0492, 0.04897, 0.04874, 0.04851, 0.04828, 0.04805, 0.04782, 0.04759, 0.04736, 0.04713, 0.0469, 0.0467, 0.0465, 0.0463, 0.0461, 0.0459, 0.0457, 0.0455, 0.0453, 0.0451, 0.0449, 0.0447, 0.0445, 0.0443, 0.0441, 0.0439, 0.0437, 0.0435, 0.0433, 0.0431, 0.0429, 0.042715, 0.04253, 0.042345, 0.04216, 0.041975, 0.04179, 0.041605, 0.04142, 0.041235, 0.04105, 0.040865, 0.04068, 0.040495, 0.04031, 0.040125, 0.03994, 0.039755, 0.03957, 0.039385, 0.0392, 0.03904, 0.03888, 0.03872, 0.03856, 0.0384, 0.03824, 0.03808, 0.03792, 0.03776, 0.0376, 0.03744, 0.03728, 0.03712, 0.03696, 0.0368, 0.03664, 0.03648, 0.03632, 0.03616, 0.036, 0.03585, 0.0357, 0.03555, 0.0354, 0.03525, 0.0351, 0.03495, 0.0348, 0.03465, 0.0345, 0.03435, 0.0342, 0.03405, 0.0339, 0.03375, 0.0336, 0.03345, 0.0333, 0.03315, 0.033, 0.03287, 0.03274, 0.03261, 0.03248, 0.03235, 0.03222, 0.03209, 0.03196, 0.03183, 0.0317, 0.03157, 0.03144, 0.03131, 0.03118, 0.03105, 0.03092, 0.03079, 0.03066, 0.03053, 0.0304, 0.030285, 0.03017, 0.030055, 0.02994, 0.029825, 0.02971, 0.029595, 0.02948, 0.029365, 0.02925, 0.029135, 0.02902, 0.028905, 0.02879, 0.028675, 0.02856, 0.028445, 0.02833, 0.028215, 0.0281, 0.027995, 0.02789, 0.027785, 0.02768, 0.027575, 0.02747, 0.027365, 0.02726, 0.027155, 0.02705, 0.026945, 0.02684, 0.026735, 0.02663, 0.026525, 0.02642, 0.026315, 0.02621, 0.026105, 0.026, 0.025905, 0.02581, 0.025715, 0.02562, 0.025525, 0.02543, 0.025335, 0.02524, 0.025145, 0.02505, 0.024955, 0.02486, 0.024765, 0.02467, 0.024575, 0.02448, 0.024385, 0.02429, 0.024195, 0.0241, 0.024015, 0.02393, 0.023845, 0.02376, 0.023675, 0.02359, 0.023505, 0.02342, 0.023335, 0.02325, 0.023165, 0.02308, 0.022995, 0.02291, 0.022825, 0.02274, 0.022655, 0.02257, 0.022485, 0.0224, 0.02232, 0.02224, 0.02216, 0.02208, 0.022, 0.02192, 0.02184, 0.02176, 0.02168, 0.0216, 0.02152, 0.02144, 0.02136, 0.02128, 0.0212, 0.02112, 0.02104, 0.02096, 0.02088, 0.0208, 0.02073, 0.02066, 0.02059, 0.02052, 0.02045, 0.02038, 0.02031, 0.02024, 0.02017, 0.0201, 0.02003, 0.01996, 0.01989, 0.01982, 0.01975, 0.01968, 0.01961, 0.01954, 0.01947, 0.0194, 0.019335, 0.01927, 0.019205, 0.01914, 0.019075, 0.01901, 0.018945, 0.01888, 0.018815, 0.01875, 0.018685, 0.01862, 0.018555, 0.01849, 0.018425, 0.01836, 0.018295, 0.01823, 0.018165, 0.0181, 0.018045, 0.01799, 0.017935, 0.01788, 0.017825, 0.01777, 0.017715, 0.01766, 0.017605, 0.01755, 0.017495, 0.01744, 0.017385, 0.01733, 0.017275, 0.01722, 0.017165, 0.01711, 0.017055, 0.017, 0.016945, 0.01689, 0.016835, 0.01678, 0.016725, 0.01667, 0.016615, 0.01656, 0.016505, 0.01645, 0.016395, 0.01634, 0.016285, 0.01623, 0.016175, 0.01612, 0.016065, 0.01601, 0.015955, 0.0159, 0.01585, 0.0158, 0.01575, 0.0157, 0.01565, 0.0156, 0.01555, 0.0155, 0.01545, 0.0154, 0.01535, 0.0153, 0.01525, 0.0152, 0.01515, 0.0151, 0.01505, 0.015, 0.01495, 0.0149, 0.014855, 0.01481, 0.014765, 0.01472, 0.014675, 0.01463, 0.014585, 0.01454, 0.014495, 0.01445, 0.014405, 0.01436, 0.014315, 0.01427, 0.014225, 0.01418, 0.014135, 0.01409, 0.014045, 0.014, 0.01396, 0.01392, 0.01388, 0.01384, 0.0138, 0.01376, 0.01372, 0.01368, 0.01364, 0.0136, 0.01356, 0.01352, 0.01348, 0.01344, 0.0134, 0.01336, 0.01332, 0.01328, 0.01324, 0.0132};

//SM Higgs WH
const double sigmaLHCHiggsWH7TeV[324]={321, 80, 400, 2.341, 2.258, 2.179, 2.104, 2.031, 1.963, 1.896, 1.831, 1.77, 1.711, 1.654, 1.6, 1.548, 1.498, 1.45, 1.404, 1.359, 1.315, 1.274, 1.234, 1.195, 1.159, 1.125, 1.091, 1.058, 1.029, 0.9964, 0.9674, 0.9384, 0.9109, 0.8847, 0.8587, 0.8333, 0.8093, 0.7858, 0.7626, 0.7415, 0.7203, 0.7002, 0.6808, 0.6617, 0.6448, 0.6268, 0.61, 0.5944, 0.5785, 0.5629, 0.5476, 0.5332, 0.5189, 0.5059, 0.4922, 0.4795, 0.4668, 0.4549, 0.4431, 0.4318, 0.4207, 0.4098, 0.3996, 0.3896, 0.3799, 0.3704, 0.3611, 0.3524, 0.3437, 0.3351, 0.3269, 0.319, 0.3109, 0.3034, 0.29585, 0.2883, 0.28125, 0.2742, 0.26695, 0.2597, 0.25245, 0.2452, 0.2384, 0.2316, 0.22785, 0.2241, 0.22045, 0.2168, 0.2133, 0.2085, 0.20395, 0.1994, 0.1951, 0.1908, 0.1867, 0.1826, 0.1787, 0.1748, 0.1709, 0.1674, 0.16395, 0.1605, 0.15715, 0.1538, 0.151, 0.1482, 0.14545, 0.1427, 0.1401, 0.1374, 0.1347, 0.132, 0.12945, 0.1269, 0.12445, 0.122, 0.11965, 0.1173, 0.1151, 0.1129, 0.11075, 0.1086, 0.10655, 0.1045, 0.10255, 0.1006, 0.09875, 0.0969, 0.0951, 0.0933, 0.0916, 0.0899, 0.0883, 0.0867, 0.08515, 0.0836, 0.0821, 0.0806, 0.07915, 0.0777, 0.07635, 0.075, 0.0737, 0.0724, 0.07115, 0.0699, 0.0687, 0.0675, 0.0663, 0.0651, 0.064, 0.0629, 0.06185, 0.0608, 0.0598, 0.0588, 0.0578, 0.0568, 0.0559, 0.055, 0.05405, 0.0531, 0.05225, 0.0514, 0.05055, 0.0497, 0.0489, 0.0481, 0.04735, 0.0466, 0.04585, 0.0451, 0.0444, 0.0437, 0.043, 0.0423, 0.04165, 0.041, 0.04035, 0.0397, 0.03905, 0.0384, 0.0378, 0.0372, 0.03665, 0.0361, 0.03555, 0.035, 0.03445, 0.0339, 0.0334, 0.0329, 0.0324, 0.0319, 0.03145, 0.031, 0.0305, 0.03, 0.02955, 0.0291, 0.0287, 0.0283, 0.02785, 0.0274, 0.027, 0.0266, 0.0262, 0.0258, 0.02545, 0.0251, 0.02475, 0.0244, 0.02405, 0.0237, 0.02335, 0.023, 0.02265, 0.0223, 0.022, 0.0217, 0.0214, 0.0211, 0.0208, 0.0205, 0.02022, 0.01994, 0.01966, 0.01938, 0.0191, 0.01884, 0.01858, 0.01832, 0.01806, 0.0178, 0.01756, 0.01732, 0.01708, 0.01684, 0.0166, 0.01638, 0.01616, 0.01594, 0.01572, 0.0155, 0.0153, 0.0151, 0.0149, 0.0147, 0.0145, 0.0143, 0.0141, 0.0139, 0.0137, 0.0135, 0.01332, 0.01314, 0.01296, 0.01278, 0.0126, 0.01244, 0.01228, 0.01212, 0.01196, 0.0118, 0.01164, 0.01148, 0.01132, 0.01116, 0.011, 0.01086, 0.01072, 0.01058, 0.01044, 0.0103, 0.01018, 0.01006, 0.00994, 0.00982, 0.0097, 0.00958, 0.00946, 0.00934, 0.00922, 0.0091, 0.009, 0.0089, 0.0088, 0.0087, 0.0086, 0.0085, 0.0084, 0.0083, 0.0082, 0.0081, 0.00801, 0.00792, 0.00783, 0.00774, 0.00765, 0.00756, 0.00747, 0.00738, 0.00729, 0.0072, 0.00713, 0.00706, 0.00699, 0.00692, 0.00685, 0.00678, 0.00671, 0.00664, 0.00657, 0.0065, 0.00643, 0.00636, 0.00629, 0.00622, 0.00615, 0.00608, 0.00601, 0.00594, 0.00587, 0.0058};

//SM Higgs ZH
const double sigmaLHCHiggsZH7TeV[324]={321, 80, 400, 1.244, 1.203, 1.163, 1.125, 1.087, 1.052, 1.019, 0.9858, 0.9548, 0.9244, 0.8959, 0.8682, 0.8417, 0.8162, 0.7917, 0.7678, 0.7447, 0.7232, 0.7011, 0.6814, 0.6616, 0.6425, 0.624, 0.6063, 0.5895, 0.5724, 0.5564, 0.5412, 0.5261, 0.5116, 0.4978, 0.4845, 0.471, 0.4586, 0.446, 0.4345, 0.4232, 0.4119, 0.4013, 0.3909, 0.3808, 0.3711, 0.3618, 0.3525, 0.3436, 0.3351, 0.3267, 0.3184, 0.3106, 0.3031, 0.2957, 0.2883, 0.2813, 0.2746, 0.268, 0.2616, 0.2555, 0.2495, 0.2436, 0.2377, 0.2322, 0.2269, 0.2216, 0.2165, 0.2117, 0.2068, 0.2019, 0.1973, 0.1928, 0.1884, 0.1842, 0.18, 0.1758, 0.1719, 0.168, 0.16395, 0.1599, 0.15585, 0.1518, 0.148, 0.1442, 0.14195, 0.1397, 0.13755, 0.1354, 0.1334, 0.1305, 0.12785, 0.1252, 0.1226, 0.12, 0.11755, 0.1151, 0.1127, 0.1103, 0.108, 0.1056, 0.1034, 0.1012, 0.09905, 0.0969, 0.09515, 0.0934, 0.0917, 0.09, 0.0884, 0.0867, 0.08505, 0.0834, 0.08185, 0.0803, 0.0788, 0.0773, 0.07585, 0.0744, 0.0731, 0.0717, 0.0704, 0.0691, 0.0678, 0.0665, 0.0653, 0.0641, 0.06295, 0.0618, 0.06065, 0.0595, 0.0584, 0.0573, 0.0563, 0.0553, 0.0543, 0.0533, 0.05235, 0.0514, 0.0505, 0.0496, 0.0487, 0.0478, 0.04695, 0.0461, 0.0453, 0.0445, 0.0437, 0.0429, 0.04215, 0.0414, 0.0407, 0.04, 0.0393, 0.0386, 0.03795, 0.0373, 0.03665, 0.036, 0.0354, 0.0348, 0.0342, 0.0336, 0.03305, 0.0325, 0.03195, 0.0314, 0.03085, 0.0303, 0.0298, 0.0293, 0.0288, 0.0283, 0.02785, 0.0274, 0.02695, 0.0265, 0.02605, 0.0256, 0.0252, 0.0248, 0.0244, 0.024, 0.0236, 0.0232, 0.0228, 0.0224, 0.02205, 0.0217, 0.02135, 0.021, 0.02065, 0.0203, 0.02, 0.0197, 0.0194, 0.0191, 0.0188, 0.0185, 0.0182, 0.0179, 0.0176, 0.0173, 0.01705, 0.0168, 0.01655, 0.0163, 0.01605, 0.0158, 0.01555, 0.0153, 0.0151, 0.0149, 0.01465, 0.0144, 0.0142, 0.014, 0.0138, 0.0136, 0.0134, 0.0132, 0.013, 0.0128, 0.0126, 0.0124, 0.01222, 0.01204, 0.01186, 0.01168, 0.0115, 0.01134, 0.01118, 0.01102, 0.01086, 0.0107, 0.01054, 0.01038, 0.01022, 0.01006, 0.0099, 0.00976, 0.00962, 0.00948, 0.00934, 0.0092, 0.00908, 0.00896, 0.00884, 0.00872, 0.0086, 0.00848, 0.00836, 0.00824, 0.00812, 0.008, 0.0079, 0.0078, 0.0077, 0.0076, 0.0075, 0.0074, 0.0073, 0.0072, 0.0071, 0.007, 0.0069, 0.0068, 0.0067, 0.0066, 0.0065, 0.0064, 0.0063, 0.0062, 0.0061, 0.006, 0.00593, 0.00586, 0.00579, 0.00572, 0.00565, 0.00558, 0.00551, 0.00544, 0.00537, 0.0053, 0.00524, 0.00518, 0.00512, 0.00506, 0.005, 0.00494, 0.00488, 0.00482, 0.00476, 0.0047, 0.00465, 0.0046, 0.00455, 0.0045, 0.00445, 0.0044, 0.00435, 0.0043, 0.00425, 0.0042, 0.00416, 0.00412, 0.00408, 0.00404, 0.004, 0.00396, 0.00392, 0.00388, 0.00384, 0.0038, 0.00376, 0.00372, 0.00368, 0.00364, 0.0036, 0.00356, 0.00352, 0.00348, 0.00344, 0.0034};

//SM Higgs ttH
const double sigmaLHCHiggsttH7TeV[324]={321, 80, 400, 0.2897, 0.2812, 0.2729, 0.265, 0.2573, 0.2498, 0.2426, 0.2357, 0.229, 0.2225, 0.2162, 0.2102, 0.2044, 0.1988, 0.1933, 0.188, 0.1828, 0.1778, 0.173, 0.1683, 0.1637, 0.1593, 0.1551, 0.151, 0.1471, 0.1432, 0.1395, 0.1359, 0.1324, 0.129, 0.1257, 0.1224, 0.1193, 0.1163, 0.1133, 0.1105, 0.1078, 0.1051, 0.1025, 0.1, 0.0976, 0.0952, 0.0929, 0.0906, 0.0884, 0.0863, 0.0843, 0.0823, 0.0803, 0.0784, 0.0766, 0.0748, 0.0731, 0.0714, 0.0698, 0.0682, 0.0666, 0.0651, 0.0636, 0.0622, 0.0608, 0.0594, 0.0581, 0.0568, 0.0555, 0.0543, 0.0531, 0.052, 0.0508, 0.0497, 0.0487, 0.04765, 0.0466, 0.04565, 0.0447, 0.0438, 0.0429, 0.042, 0.0411, 0.04025, 0.0394, 0.0386, 0.0378, 0.03705, 0.0363, 0.0356, 0.0349, 0.0342, 0.0335, 0.03285, 0.0322, 0.03155, 0.0309, 0.0303, 0.0297, 0.0292, 0.0286, 0.02805, 0.0275, 0.027, 0.0265, 0.026, 0.0255, 0.02505, 0.0246, 0.0242, 0.0237, 0.0233, 0.0229, 0.0225, 0.0221, 0.0217, 0.0213, 0.0209, 0.0205, 0.0202, 0.0198, 0.01945, 0.0191, 0.0188, 0.0185, 0.0182, 0.0179, 0.0176, 0.0173, 0.017, 0.0167, 0.0164, 0.0161, 0.01585, 0.0156, 0.01535, 0.0151, 0.01485, 0.0146, 0.0144, 0.0142, 0.01395, 0.0137, 0.0135, 0.0133, 0.0131, 0.0129, 0.0127, 0.0125, 0.0123, 0.0121, 0.01195, 0.0118, 0.0116, 0.0114, 0.01125, 0.0111, 0.01095, 0.0108, 0.01065, 0.0105, 0.01035, 0.0102, 0.01005, 0.0099, 0.00975, 0.0096, 0.00945, 0.0093, 0.0092, 0.0091, 0.00895, 0.0088, 0.0087, 0.0086, 0.0085, 0.0084, 0.00825, 0.0081, 0.008, 0.0079, 0.0078, 0.0077, 0.0076, 0.0075, 0.0074, 0.0073, 0.00725, 0.0072, 0.0071, 0.007, 0.0069, 0.0068, 0.0067, 0.0066, 0.00655, 0.0065, 0.0064, 0.0063, 0.00625, 0.0062, 0.0061, 0.006, 0.00595, 0.0059, 0.00585, 0.0058, 0.0057, 0.0056, 0.00555, 0.0055, 0.00545, 0.0054, 0.00535, 0.0053, 0.0052, 0.0051, 0.00505, 0.005, 0.00495, 0.0049, 0.00485, 0.0048, 0.00475, 0.0047, 0.00466, 0.00462, 0.00458, 0.00454, 0.0045, 0.00446, 0.00442, 0.00438, 0.00434, 0.0043, 0.00424, 0.00418, 0.00412, 0.00406, 0.004, 0.00398, 0.00396, 0.00394, 0.00392, 0.0039, 0.00386, 0.00382, 0.00378, 0.00374, 0.0037, 0.00366, 0.00362, 0.00358, 0.00354, 0.0035, 0.00346, 0.00342, 0.00338, 0.00334, 0.0033, 0.00328, 0.00326, 0.00324, 0.00322, 0.0032, 0.00318, 0.00316, 0.00314, 0.00312, 0.0031, 0.00306, 0.00302, 0.00298, 0.00294, 0.0029, 0.00288, 0.00286, 0.00284, 0.00282, 0.0028, 0.00278, 0.00276, 0.00274, 0.00272, 0.0027, 0.00268, 0.00266, 0.00264, 0.00262, 0.0026, 0.00258, 0.00256, 0.00254, 0.00252, 0.0025, 0.00248, 0.00246, 0.00244, 0.00242, 0.0024, 0.00238, 0.00236, 0.00234, 0.00232, 0.0023, 0.00228, 0.00226, 0.00224, 0.00222, 0.0022, 0.00218, 0.00216, 0.00214, 0.00212, 0.0021, 0.00208, 0.00206, 0.00204, 0.00202, 0.002, 0.00198, 0.00196, 0.00194, 0.00192, 0.0019};


///// SM Higgs cross sections (in pb) at the LHC tables at 8 TeV as a function of mH in steps of 1 GeV (extracted from https://twiki.cern.ch/twiki/bin/view/LHCPhysics/CERNYellowReportPageAt8TeV)

//SM Higgs ggF 
const double sigmaLHCHiggsggF8TeV[924]={921, 80, 1000, 45.3698, 44.3055, 43.2791, 42.2899, 41.3349, 40.4122, 39.5212, 38.6601, 37.8271, 37.0214, 36.2305, 35.4855, 34.7531, 34.0439, 33.3556, 32.6879, 32.0401, 31.4104, 30.7994, 30.2058, 29.6811, 29.1181, 28.5705, 28.0377, 27.521, 27.0052, 26.5167, 26.0531, 25.5904, 25.1391, 24.6986, 24.2692, 23.8491, 23.4417, 23.0451, 22.6588, 22.2818, 21.9139, 21.5547, 21.2044, 20.8622, 20.5285, 20.2021, 19.8837, 19.5724, 19.2681, 18.9708, 18.6801, 18.3959, 18.1178, 17.8456, 17.58, 17.3199, 17.0656, 16.8161, 16.5718, 16.3325, 16.0981, 15.8688, 15.6439, 15.4235, 15.265, 15.0607, 14.8585, 14.6594, 14.4635, 14.2729, 14.0906, 13.9076, 13.7282, 13.5503, 13.3838, 13.2174, 13.0557, 12.8939, 12.7356, 12.5772, 12.4221, 12.267, 12.1134, 11.9598, 11.7814, 11.6029, 11.3847, 11.1665, 10.9739, 10.7935, 10.6261, 10.4587, 10.3141, 10.1694, 10.0331, 9.8967, 9.77065, 9.6446, 9.526, 9.41, 9.30185, 9.1937, 9.0866, 8.9795, 8.8671, 8.7547, 8.628, 8.5013, 8.3825, 8.2655, 8.159, 8.0525, 7.9554, 7.8583, 7.76475, 7.6712, 7.5827, 7.4942, 7.4054, 7.3199, 7.2533, 7.1867, 7.13385, 7.081, 7.0088, 6.9366, 6.8913, 6.846, 6.78835, 6.7307, 6.67, 6.6093, 6.5544, 6.4995, 6.44315, 6.3868, 6.3397, 6.2926, 6.25335, 6.2141, 6.15905, 6.104, 6.05355, 6.0031, 5.9541, 5.9051, 5.863, 5.8209, 5.7844, 5.7479, 5.70045, 5.653, 5.6101, 5.5672, 5.52725, 5.4873, 5.44995, 5.4126, 5.36975, 5.3269, 5.2868, 5.2467, 5.20265, 5.1586, 5.1182, 5.0778, 5.03815, 4.9985, 4.96125, 4.924, 4.88905, 4.8541, 4.8184, 4.7827, 4.74855, 4.7144, 4.6807, 4.647, 4.6147, 4.5824, 4.5519, 4.5214, 4.4912, 4.461, 4.43285, 4.4047, 4.37715, 4.3496, 4.3206, 4.2916, 4.2642, 4.2368, 4.21045, 4.1841, 4.1591, 4.1341, 4.1101, 4.0861, 4.06285, 4.0396, 4.0167, 3.9938, 3.9721, 3.9504, 3.9293, 3.9082, 3.8876, 3.867, 3.84775, 3.8285, 3.81045, 3.7924, 3.7736, 3.7548, 3.73735, 3.7199, 3.7032, 3.6865, 3.6703, 3.6541, 3.63885, 3.6236, 3.609, 3.5944, 3.58124, 3.56808, 3.55492, 3.54176, 3.5286, 3.5173, 3.506, 3.4947, 3.4834, 3.4721, 3.46262, 3.45314, 3.44366, 3.43418, 3.4247, 3.4164, 3.4081, 3.3998, 3.3915, 3.3832, 3.37764, 3.37208, 3.36652, 3.36096, 3.3554, 3.35258, 3.34976, 3.34694, 3.34412, 3.3413, 3.34124, 3.34118, 3.34112, 3.34106, 3.341, 3.34468, 3.34836, 3.35204, 3.35572, 3.3594, 3.36722, 3.37504, 3.38286, 3.39068, 3.3985, 3.3989, 3.3993, 3.3997, 3.4001, 3.4005, 3.39891, 3.39732, 3.39573, 3.39414, 3.39255, 3.39096, 3.38937, 3.38778, 3.38619, 3.3846, 3.37933, 3.37406, 3.36879, 3.36352, 3.35825, 3.35298, 3.34771, 3.34244, 3.33717, 3.3319, 3.32181, 3.31172, 3.30163, 3.29154, 3.28145, 3.27136, 3.26127, 3.25118, 3.24109, 3.231, 3.21683, 3.20266, 3.18849, 3.17432, 3.16015, 3.14598, 3.13181, 3.11764, 3.10347, 3.0893, 3.07245, 3.0556, 3.03875, 3.0219, 3.00505, 2.9882, 2.97135, 2.9545, 2.93765, 2.9208, 2.90225, 2.8837, 2.86515, 2.8466, 2.82805, 2.8095, 2.79095, 2.7724, 2.75385, 2.7353, 2.71675, 2.6982, 2.67965, 2.6611, 2.64255, 2.624, 2.60545, 2.5869, 2.56835, 2.5498, 2.53123, 2.51265, 2.49408, 2.4755, 2.45693, 2.43835, 2.41978, 2.4012, 2.38263, 2.36405, 2.34548, 2.3269, 2.30833, 2.28975, 2.27118, 2.2526, 2.23403, 2.21545, 2.19688, 2.1783, 2.16071, 2.14312, 2.12553, 2.10794, 2.09035, 2.07276, 2.05517, 2.03758, 2.01999, 2.0024, 1.98581, 1.96922, 1.95263, 1.93604, 1.91945, 1.90286, 1.88627, 1.86968, 1.85309, 1.8365, 1.82155, 1.8066, 1.79165, 1.7767, 1.76175, 1.7468, 1.73185, 1.7169, 1.70195, 1.687, 1.67205, 1.6571, 1.64215, 1.6272, 1.61225, 1.5973, 1.58235, 1.5674, 1.55245, 1.5375, 1.52477, 1.51203, 1.4993, 1.48656, 1.47383, 1.46109, 1.44836, 1.43562, 1.42289, 1.41015, 1.39742, 1.38468, 1.37195, 1.35921, 1.34647, 1.33374, 1.32101, 1.30827, 1.29553, 1.2828, 1.27211, 1.26141, 1.25072, 1.24002, 1.22933, 1.21863, 1.20794, 1.19724, 1.18655, 1.17585, 1.16516, 1.15446, 1.14377, 1.13307, 1.12238, 1.11168, 1.10098, 1.09029, 1.07959, 1.0689, 1.06002, 1.05114, 1.04226, 1.03338, 1.0245, 1.01562, 1.00674, 0.99786, 0.98898, 0.9801, 0.97122, 0.96234, 0.95346, 0.94458, 0.9357, 0.92682, 0.91794, 0.90906, 0.90018, 0.8913, 0.88361, 0.87592, 0.86823, 0.86054, 0.85285, 0.84516, 0.83747, 0.82978, 0.82209, 0.8144, 0.80738, 0.80036, 0.79334, 0.78632, 0.7793, 0.77228, 0.76526, 0.75824, 0.75122, 0.7442, 0.73813, 0.73206, 0.72599, 0.71992, 0.71385, 0.70778, 0.70171, 0.69564, 0.68957, 0.6835, 0.67743, 0.67136, 0.66529, 0.65922, 0.65315, 0.64708, 0.64101, 0.63494, 0.62887, 0.6228, 0.61781, 0.61282, 0.60783, 0.60284, 0.59785, 0.59286, 0.58787, 0.58288, 0.57789, 0.5729, 0.56791, 0.56292, 0.55793, 0.55294, 0.54795, 0.54296, 0.53797, 0.53298, 0.52799, 0.523, 0.518865, 0.51473, 0.510595, 0.50646, 0.502325, 0.49819, 0.494055, 0.48992, 0.485785, 0.48165, 0.477515, 0.47338, 0.469245, 0.46511, 0.460975, 0.45684, 0.452705, 0.44857, 0.444435, 0.4403, 0.43688, 0.43346, 0.43004, 0.42662, 0.4232, 0.41978, 0.41636, 0.41294, 0.40952, 0.4061, 0.40268, 0.39926, 0.39584, 0.39242, 0.389, 0.38558, 0.38216, 0.37874, 0.37532, 0.3719, 0.36895, 0.366, 0.36305, 0.3601, 0.35715, 0.3542, 0.35125, 0.3483, 0.34535, 0.3424, 0.33969, 0.33698, 0.33427, 0.33156, 0.32885, 0.32614, 0.32343, 0.32072, 0.31801, 0.3153, 0.312945, 0.31059, 0.308235, 0.30588, 0.303525, 0.30117, 0.298815, 0.29646, 0.294105, 0.29175, 0.289395, 0.28704, 0.284685, 0.28233, 0.279975, 0.27762, 0.275265, 0.27291, 0.270555, 0.2682, 0.26624, 0.26428, 0.26232, 0.26036, 0.2584, 0.25644, 0.25448, 0.25252, 0.25056, 0.2486, 0.24664, 0.24468, 0.24272, 0.24076, 0.2388, 0.23684, 0.23488, 0.23292, 0.23096, 0.229, 0.22737, 0.22574, 0.22411, 0.22248, 0.22085, 0.21922, 0.21759, 0.21596, 0.21433, 0.2127, 0.21107, 0.20944, 0.20781, 0.20618, 0.20455, 0.20292, 0.20129, 0.19966, 0.19803, 0.1964, 0.195025, 0.19365, 0.192275, 0.1909, 0.189525, 0.18815, 0.186775, 0.1854, 0.184025, 0.18265, 0.181275, 0.1799, 0.178525, 0.17715, 0.175775, 0.1744, 0.173025, 0.17165, 0.170275, 0.1689, 0.16769, 0.16648, 0.16527, 0.16406, 0.16285, 0.16164, 0.16043, 0.15922, 0.15801, 0.1568, 0.15569, 0.15458, 0.15347, 0.15236, 0.15125, 0.15014, 0.14903, 0.14792, 0.14681, 0.1457, 0.144725, 0.14375, 0.142775, 0.1418, 0.140825, 0.13985, 0.138875, 0.1379, 0.136925, 0.13595, 0.134975, 0.134, 0.133025, 0.13205, 0.131075, 0.1301, 0.129125, 0.12815, 0.127175, 0.1262, 0.125375, 0.12455, 0.123725, 0.1229, 0.122075, 0.12125, 0.120425, 0.1196, 0.118775, 0.11795, 0.117125, 0.1163, 0.115475, 0.11465, 0.113825, 0.113, 0.112175, 0.11135, 0.110525, 0.1097, 0.109, 0.1083, 0.1076, 0.1069, 0.1062, 0.1055, 0.1048, 0.1041, 0.1034, 0.1027, 0.102, 0.1013, 0.1006, 0.0999, 0.0992, 0.0985, 0.0978, 0.0971, 0.0964, 0.0957, 0.0951, 0.0945, 0.0939, 0.0933, 0.0927, 0.0921, 0.0915, 0.0909, 0.0903, 0.0897, 0.0891, 0.0885, 0.0879, 0.0873, 0.0867, 0.0861, 0.0855, 0.0849, 0.0843, 0.0837, 0.08317, 0.08264, 0.08211, 0.08158, 0.08105, 0.08052, 0.07999, 0.07946, 0.07893, 0.0784, 0.07791, 0.07742, 0.07693, 0.07644, 0.07595, 0.07546, 0.07497, 0.07448, 0.07399, 0.0735, 0.07306, 0.07262, 0.07218, 0.07174, 0.0713, 0.07086, 0.07042, 0.06998, 0.06954, 0.0691, 0.06866, 0.06822, 0.06778, 0.06734, 0.0669, 0.06646, 0.06602, 0.06558, 0.06514, 0.0647, 0.06432, 0.06394, 0.06356, 0.06318, 0.0628, 0.06242, 0.06204, 0.06166, 0.06128, 0.0609, 0.06052, 0.06014, 0.05976, 0.05938, 0.059, 0.05862, 0.05824, 0.05786, 0.05748, 0.0571, 0.056775, 0.05645, 0.056125, 0.0558, 0.055475, 0.05515, 0.054825, 0.0545, 0.054175, 0.05385, 0.053525, 0.0532, 0.052875, 0.05255, 0.052225, 0.0519, 0.051575, 0.05125, 0.050925, 0.0506, 0.05032, 0.05004, 0.04976, 0.04948, 0.0492, 0.04892, 0.04864, 0.04836, 0.04808, 0.0478, 0.04752, 0.04724, 0.04696, 0.04668, 0.0464, 0.04612, 0.04584, 0.04556, 0.04528, 0.045, 0.04474, 0.04448, 0.04422, 0.04396, 0.0437, 0.04344, 0.04318, 0.04292, 0.04266, 0.0424, 0.04216, 0.04192, 0.04168, 0.04144, 0.0412, 0.04096, 0.04072, 0.04048, 0.04024, 0.04, 0.039785, 0.03957, 0.039355, 0.03914, 0.038925, 0.03871, 0.038495, 0.03828, 0.038065, 0.03785, 0.037635, 0.03742, 0.037205, 0.03699, 0.036775, 0.03656, 0.036345, 0.03613, 0.035915, 0.0357, 0.035515, 0.03533, 0.035145, 0.03496, 0.034775, 0.03459, 0.034405, 0.03422, 0.034035, 0.03385, 0.033665, 0.03348, 0.033295, 0.03311, 0.032925, 0.03274, 0.032555, 0.03237, 0.032185, 0.032};

//SM Higgs VBF 
const double sigmaLHCHiggsVBF8TeV[924]={921, 80, 1000, 2.424, 2.399, 2.364, 2.346, 2.326, 2.3, 2.283, 2.258, 2.24, 2.209, 2.191, 2.17, 2.153, 2.129, 2.108, 2.084, 2.068, 2.046, 2.027, 2.004, 1.988, 1.967, 1.945, 1.933, 1.914, 1.897, 1.877, 1.862, 1.841, 1.826, 1.809, 1.791, 1.78, 1.764, 1.743, 1.729, 1.714, 1.699, 1.683, 1.666, 1.649, 1.636, 1.623, 1.608, 1.595, 1.578, 1.568, 1.552, 1.54, 1.525, 1.511, 1.497, 1.485, 1.473, 1.462, 1.448, 1.436, 1.423, 1.412, 1.4, 1.389, 1.377, 1.365, 1.354, 1.344, 1.333, 1.321, 1.311, 1.302, 1.291, 1.28, 1.2695, 1.259, 1.2495, 1.24, 1.231, 1.222, 1.213, 1.204, 1.1945, 1.185, 1.178, 1.171, 1.1615, 1.152, 1.141, 1.132, 1.123, 1.114, 1.106, 1.098, 1.089, 1.08, 1.071, 1.062, 1.055, 1.047, 1.039, 1.031, 1.023, 1.015, 1.0065, 0.998, 0.9905, 0.983, 0.976, 0.969, 0.9613, 0.9536, 0.94615, 0.9387, 0.93125, 0.9238, 0.9164, 0.909, 0.9018, 0.8953, 0.8886, 0.8819, 0.8752, 0.8685, 0.86265, 0.8568, 0.8512, 0.8456, 0.8406, 0.8356, 0.83075, 0.8259, 0.8211, 0.8163, 0.8115, 0.8067, 0.80185, 0.797, 0.79215, 0.7873, 0.78245, 0.7776, 0.77265, 0.7677, 0.7628, 0.7579, 0.753, 0.7481, 0.7431, 0.7381, 0.7334, 0.7287, 0.72385, 0.719, 0.71425, 0.7095, 0.7047, 0.6999, 0.6951, 0.6903, 0.68545, 0.6806, 0.67545, 0.6703, 0.66535, 0.6604, 0.6555, 0.6506, 0.6458, 0.641, 0.63645, 0.6319, 0.6272, 0.6225, 0.61805, 0.6136, 0.6093, 0.605, 0.6007, 0.5964, 0.59215, 0.5879, 0.5838, 0.5797, 0.57555, 0.5714, 0.5675, 0.5636, 0.5595, 0.5554, 0.55155, 0.5477, 0.5439, 0.5401, 0.53645, 0.5328, 0.52915, 0.5255, 0.52195, 0.5184, 0.51495, 0.5115, 0.508, 0.5045, 0.50115, 0.4978, 0.49445, 0.4911, 0.4878, 0.4845, 0.48125, 0.478, 0.4748, 0.4716, 0.4685, 0.4654, 0.46225, 0.4591, 0.45605, 0.453, 0.44995, 0.4469, 0.44385, 0.4408, 0.43798, 0.43516, 0.43234, 0.42952, 0.4267, 0.424, 0.4213, 0.4186, 0.4159, 0.4132, 0.41056, 0.40792, 0.40528, 0.40264, 0.4, 0.3975, 0.395, 0.3925, 0.39, 0.3875, 0.38506, 0.38262, 0.38018, 0.37774, 0.3753, 0.373, 0.3707, 0.3684, 0.3661, 0.3638, 0.36156, 0.35932, 0.35708, 0.35484, 0.3526, 0.35052, 0.34844, 0.34636, 0.34428, 0.3422, 0.33986, 0.33752, 0.33518, 0.33284, 0.3305, 0.3284, 0.3263, 0.3242, 0.3221, 0.32, 0.31828, 0.31656, 0.31484, 0.31312, 0.3114, 0.30968, 0.30796, 0.30624, 0.30452, 0.3028, 0.30148, 0.30016, 0.29884, 0.29752, 0.2962, 0.29488, 0.29356, 0.29224, 0.29092, 0.2896, 0.2884, 0.2872, 0.286, 0.2848, 0.2836, 0.2824, 0.2812, 0.28, 0.2788, 0.2776, 0.27644, 0.27528, 0.27412, 0.27296, 0.2718, 0.27064, 0.26948, 0.26832, 0.26716, 0.266, 0.26483, 0.26366, 0.26249, 0.26132, 0.26015, 0.25898, 0.25781, 0.25664, 0.25547, 0.2543, 0.25317, 0.25204, 0.25091, 0.24978, 0.24865, 0.24752, 0.24639, 0.24526, 0.24413, 0.243, 0.24187, 0.24074, 0.23961, 0.23848, 0.23735, 0.23622, 0.23509, 0.23396, 0.23283, 0.2317, 0.23063, 0.22956, 0.22849, 0.22742, 0.22635, 0.22528, 0.22421, 0.22314, 0.22207, 0.221, 0.21993, 0.21886, 0.21779, 0.21672, 0.21565, 0.21458, 0.21351, 0.21244, 0.21137, 0.2103, 0.20929, 0.20828, 0.20727, 0.20626, 0.20525, 0.20424, 0.20323, 0.20222, 0.20121, 0.2002, 0.19923, 0.19826, 0.19729, 0.19632, 0.19535, 0.19438, 0.19341, 0.19244, 0.19147, 0.1905, 0.189595, 0.18869, 0.187785, 0.18688, 0.185975, 0.18507, 0.184165, 0.18326, 0.182355, 0.18145, 0.180545, 0.17964, 0.178735, 0.17783, 0.176925, 0.17602, 0.175115, 0.17421, 0.173305, 0.1724, 0.171585, 0.17077, 0.169955, 0.16914, 0.168325, 0.16751, 0.166695, 0.16588, 0.165065, 0.16425, 0.163435, 0.16262, 0.161805, 0.16099, 0.160175, 0.15936, 0.158545, 0.15773, 0.156915, 0.1561, 0.155365, 0.15463, 0.153895, 0.15316, 0.152425, 0.15169, 0.150955, 0.15022, 0.149485, 0.14875, 0.148015, 0.14728, 0.146545, 0.14581, 0.145075, 0.14434, 0.143605, 0.14287, 0.142135, 0.1414, 0.140745, 0.14009, 0.139435, 0.13878, 0.138125, 0.13747, 0.136815, 0.13616, 0.135505, 0.13485, 0.134195, 0.13354, 0.132885, 0.13223, 0.131575, 0.13092, 0.130265, 0.12961, 0.128955, 0.1283, 0.1277, 0.1271, 0.1265, 0.1259, 0.1253, 0.1247, 0.1241, 0.1235, 0.1229, 0.1223, 0.12173, 0.12116, 0.12059, 0.12002, 0.11945, 0.11888, 0.11831, 0.11774, 0.11717, 0.1166, 0.11608, 0.11556, 0.11504, 0.11452, 0.114, 0.11348, 0.11296, 0.11244, 0.11192, 0.1114, 0.11088, 0.11036, 0.10984, 0.10932, 0.1088, 0.10828, 0.10776, 0.10724, 0.10672, 0.1062, 0.105735, 0.10527, 0.104805, 0.10434, 0.103875, 0.10341, 0.102945, 0.10248, 0.102015, 0.10155, 0.101085, 0.10062, 0.100155, 0.09969, 0.099225, 0.09876, 0.098295, 0.09783, 0.097365, 0.0969, 0.096485, 0.09607, 0.095655, 0.09524, 0.094825, 0.09441, 0.093995, 0.09358, 0.093165, 0.09275, 0.092335, 0.09192, 0.091505, 0.09109, 0.090675, 0.09026, 0.089845, 0.08943, 0.089015, 0.0886, 0.08823, 0.08786, 0.08749, 0.08712, 0.08675, 0.08638, 0.08601, 0.08564, 0.08527, 0.0849, 0.08453, 0.08416, 0.08379, 0.08342, 0.08305, 0.08268, 0.08231, 0.08194, 0.08157, 0.0812, 0.08086, 0.08052, 0.08018, 0.07984, 0.0795, 0.07916, 0.07882, 0.07848, 0.07814, 0.0778, 0.07748, 0.07716, 0.07684, 0.07652, 0.0762, 0.07588, 0.07556, 0.07524, 0.07492, 0.0746, 0.074305, 0.07401, 0.073715, 0.07342, 0.073125, 0.07283, 0.072535, 0.07224, 0.071945, 0.07165, 0.071355, 0.07106, 0.070765, 0.07047, 0.070175, 0.06988, 0.069585, 0.06929, 0.068995, 0.0687, 0.06843, 0.06816, 0.06789, 0.06762, 0.06735, 0.06708, 0.06681, 0.06654, 0.06627, 0.066, 0.06573, 0.06546, 0.06519, 0.06492, 0.06465, 0.06438, 0.06411, 0.06384, 0.06357, 0.0633, 0.06306, 0.06282, 0.06258, 0.06234, 0.0621, 0.06186, 0.06162, 0.06138, 0.06114, 0.0609, 0.06066, 0.06042, 0.06018, 0.05994, 0.0597, 0.05946, 0.05922, 0.05898, 0.05874, 0.0585, 0.058285, 0.05807, 0.057855, 0.05764, 0.057425, 0.05721, 0.056995, 0.05678, 0.056565, 0.05635, 0.056135, 0.05592, 0.055705, 0.05549, 0.055275, 0.05506, 0.054845, 0.05463, 0.054415, 0.0542, 0.05402, 0.05384, 0.05366, 0.05348, 0.0533, 0.05312, 0.05294, 0.05276, 0.05258, 0.0524, 0.05219, 0.05198, 0.05177, 0.05156, 0.05135, 0.05114, 0.05093, 0.05072, 0.05051, 0.0503, 0.050125, 0.04995, 0.049775, 0.0496, 0.049425, 0.04925, 0.049075, 0.0489, 0.048725, 0.04855, 0.048375, 0.0482, 0.048025, 0.04785, 0.047675, 0.0475, 0.047325, 0.04715, 0.046975, 0.0468, 0.046645, 0.04649, 0.046335, 0.04618, 0.046025, 0.04587, 0.045715, 0.04556, 0.045405, 0.04525, 0.045095, 0.04494, 0.044785, 0.04463, 0.044475, 0.04432, 0.044165, 0.04401, 0.043855, 0.0437, 0.043555, 0.04341, 0.043265, 0.04312, 0.042975, 0.04283, 0.042685, 0.04254, 0.042395, 0.04225, 0.042105, 0.04196, 0.041815, 0.04167, 0.041525, 0.04138, 0.041235, 0.04109, 0.040945, 0.0408, 0.04067, 0.04054, 0.04041, 0.04028, 0.04015, 0.04002, 0.03989, 0.03976, 0.03963, 0.0395, 0.03937, 0.03924, 0.03911, 0.03898, 0.03885, 0.03872, 0.03859, 0.03846, 0.03833, 0.0382, 0.03809, 0.03798, 0.03787, 0.03776, 0.03765, 0.03754, 0.03743, 0.03732, 0.03721, 0.0371, 0.03697, 0.03684, 0.03671, 0.03658, 0.03645, 0.03632, 0.03619, 0.03606, 0.03593, 0.0358, 0.03569, 0.03558, 0.03547, 0.03536, 0.03525, 0.03514, 0.03503, 0.03492, 0.03481, 0.0347, 0.03459, 0.03448, 0.03437, 0.03426, 0.03415, 0.03404, 0.03393, 0.03382, 0.03371, 0.0336, 0.0335, 0.0334, 0.0333, 0.0332, 0.0331, 0.033, 0.0329, 0.0328, 0.0327, 0.0326, 0.0325, 0.0324, 0.0323, 0.0322, 0.0321, 0.032, 0.0319, 0.0318, 0.0317, 0.0316, 0.031515, 0.03143, 0.031345, 0.03126, 0.031175, 0.03109, 0.031005, 0.03092, 0.030835, 0.03075, 0.030665, 0.03058, 0.030495, 0.03041, 0.030325, 0.03024, 0.030155, 0.03007, 0.029985, 0.0299, 0.029815, 0.02973, 0.029645, 0.02956, 0.029475, 0.02939, 0.029305, 0.02922, 0.029135, 0.02905, 0.028965, 0.02888, 0.028795, 0.02871, 0.028625, 0.02854, 0.028455, 0.02837, 0.028285, 0.0282, 0.02813, 0.02806, 0.02799, 0.02792, 0.02785, 0.02778, 0.02771, 0.02764, 0.02757, 0.0275, 0.02742, 0.02734, 0.02726, 0.02718, 0.0271, 0.02702, 0.02694, 0.02686, 0.02678, 0.0267, 0.026625, 0.02655, 0.026475, 0.0264, 0.026325, 0.02625, 0.026175, 0.0261, 0.026025, 0.02595, 0.025875, 0.0258, 0.025725, 0.02565, 0.025575, 0.0255, 0.025425, 0.02535, 0.025275, 0.0252, 0.02514, 0.02508, 0.02502, 0.02496, 0.0249, 0.02484, 0.02478, 0.02472, 0.02466, 0.0246, 0.02454, 0.02448, 0.02442, 0.02436, 0.0243, 0.02424, 0.02418, 0.02412, 0.02406, 0.024};

//SM Higgs WH 
const double sigmaLHCHiggsWH8TeV[324]={321, 80, 400, 2.808, 2.711, 2.619, 2.528, 2.442, 2.359, 2.279, 2.203, 2.129, 2.058, 1.99, 1.929, 1.866, 1.806, 1.749, 1.695, 1.641, 1.589, 1.54, 1.495, 1.447, 1.403, 1.36, 1.319, 1.28, 1.242, 1.204, 1.169, 1.135, 1.103, 1.071, 1.04, 1.01, 0.9813, 0.9535, 0.9266, 0.9002, 0.8758, 0.8515, 0.8284, 0.8052, 0.7844, 0.7631, 0.7434, 0.7239, 0.7046, 0.686, 0.6676, 0.6501, 0.6329, 0.6169, 0.6005, 0.5856, 0.5703, 0.5556, 0.5416, 0.5277, 0.5145, 0.5018, 0.489, 0.4768, 0.4651, 0.454, 0.4426, 0.432, 0.4216, 0.4112, 0.4014, 0.3913, 0.3821, 0.3728, 0.3637, 0.3546, 0.3461, 0.3376, 0.3289, 0.3202, 0.3113, 0.3024, 0.29395, 0.2855, 0.2809, 0.2763, 0.2719, 0.2675, 0.263, 0.2575, 0.25205, 0.2466, 0.2414, 0.2362, 0.23115, 0.2261, 0.2213, 0.2165, 0.2118, 0.2076, 0.20335, 0.1991, 0.1951, 0.1911, 0.1876, 0.1841, 0.18075, 0.1774, 0.1741, 0.1707, 0.16745, 0.1642, 0.16105, 0.1579, 0.15495, 0.152, 0.1492, 0.1464, 0.1436, 0.1409, 0.13825, 0.1356, 0.13305, 0.1305, 0.1281, 0.1257, 0.1234, 0.1211, 0.11895, 0.1168, 0.11475, 0.1127, 0.1107, 0.1087, 0.10675, 0.1048, 0.10295, 0.1011, 0.09935, 0.0976, 0.09595, 0.0943, 0.09265, 0.091, 0.08945, 0.0879, 0.08645, 0.085, 0.08355, 0.0821, 0.08075, 0.0794, 0.0781, 0.0768, 0.0755, 0.0742, 0.073, 0.0718, 0.0706, 0.0694, 0.0683, 0.0672, 0.0661, 0.065, 0.06395, 0.0629, 0.0619, 0.0609, 0.05995, 0.059, 0.0581, 0.0572, 0.0563, 0.0554, 0.05455, 0.0537, 0.05285, 0.052, 0.0512, 0.0504, 0.04965, 0.0489, 0.04815, 0.0474, 0.0467, 0.046, 0.0453, 0.0446, 0.04395, 0.0433, 0.0427, 0.0421, 0.04145, 0.0408, 0.0402, 0.0396, 0.03905, 0.0385, 0.0379, 0.0373, 0.03675, 0.0362, 0.0357, 0.0352, 0.0347, 0.0342, 0.0337, 0.0332, 0.03275, 0.0323, 0.0318, 0.0313, 0.0309, 0.0305, 0.03005, 0.0296, 0.0292, 0.0288, 0.0284, 0.028, 0.0276, 0.0272, 0.02685, 0.0265, 0.02614, 0.02578, 0.02542, 0.02506, 0.0247, 0.02438, 0.02406, 0.02374, 0.02342, 0.0231, 0.0228, 0.0225, 0.0222, 0.0219, 0.0216, 0.02132, 0.02104, 0.02076, 0.02048, 0.0202, 0.01994, 0.01968, 0.01942, 0.01916, 0.0189, 0.01866, 0.01842, 0.01818, 0.01794, 0.0177, 0.01748, 0.01726, 0.01704, 0.01682, 0.0166, 0.01638, 0.01616, 0.01594, 0.01572, 0.0155, 0.0153, 0.0151, 0.0149, 0.0147, 0.0145, 0.0143, 0.0141, 0.0139, 0.0137, 0.0135, 0.01336, 0.01322, 0.01308, 0.01294, 0.0128, 0.01266, 0.01252, 0.01238, 0.01224, 0.0121, 0.01197, 0.01184, 0.01171, 0.01158, 0.01145, 0.01132, 0.01119, 0.01106, 0.01093, 0.0108, 0.01068, 0.01056, 0.01044, 0.01032, 0.0102, 0.01008, 0.00996, 0.00984, 0.00972, 0.0096, 0.0095, 0.0094, 0.0093, 0.0092, 0.0091, 0.009, 0.0089, 0.0088, 0.0087, 0.0086, 0.00852, 0.00844, 0.00836, 0.00828, 0.0082, 0.00812, 0.00804, 0.00796, 0.00788, 0.0078};

//SM Higgs ZH
const double sigmaLHCHiggsZH8TeV[324]={321, 80, 400, 1.508, 1.459, 1.411, 1.366, 1.321, 1.281, 1.238, 1.2, 1.163, 1.126, 1.092, 1.059, 1.028, 0.9965, 0.967, 0.9383, 0.9109, 0.884, 0.8592, 0.834, 0.8102, 0.7876, 0.765, 0.7436, 0.7226, 0.7022, 0.6833, 0.6646, 0.6469, 0.6296, 0.6125, 0.596, 0.5803, 0.5646, 0.5501, 0.5358, 0.5218, 0.5083, 0.4956, 0.4829, 0.471, 0.4589, 0.4478, 0.4366, 0.426, 0.4153, 0.405, 0.3953, 0.3856, 0.3762, 0.3671, 0.3583, 0.3498, 0.3418, 0.3337, 0.3259, 0.3184, 0.3109, 0.3036, 0.2966, 0.2898, 0.2831, 0.2769, 0.2705, 0.2644, 0.2583, 0.2527, 0.2469, 0.2415, 0.2361, 0.2308, 0.22575, 0.2207, 0.2158, 0.2109, 0.20595, 0.201, 0.19605, 0.1911, 0.18635, 0.1816, 0.1789, 0.1762, 0.1735, 0.1708, 0.1683, 0.1649, 0.16155, 0.1582, 0.155, 0.1518, 0.14875, 0.1457, 0.14275, 0.1398, 0.1369, 0.134, 0.1312, 0.1284, 0.12575, 0.1231, 0.1209, 0.1187, 0.1166, 0.1145, 0.1125, 0.1103, 0.10825, 0.1062, 0.1042, 0.1022, 0.10035, 0.0985, 0.0967, 0.0949, 0.0931, 0.0915, 0.0898, 0.0881, 0.0865, 0.0849, 0.0834, 0.0819, 0.08045, 0.079, 0.07755, 0.0761, 0.07475, 0.0734, 0.0721, 0.0708, 0.06955, 0.0683, 0.0671, 0.0659, 0.0648, 0.0637, 0.0626, 0.0615, 0.0604, 0.0593, 0.0583, 0.0573, 0.0563, 0.0553, 0.05435, 0.0534, 0.0525, 0.0516, 0.05075, 0.0499, 0.04905, 0.0482, 0.04735, 0.0465, 0.0457, 0.0449, 0.04415, 0.0434, 0.0427, 0.042, 0.0413, 0.0406, 0.03995, 0.0393, 0.03865, 0.038, 0.03735, 0.0367, 0.0361, 0.0355, 0.03495, 0.0344, 0.03385, 0.0333, 0.03275, 0.0322, 0.03165, 0.0311, 0.0306, 0.0301, 0.02965, 0.0292, 0.0287, 0.0282, 0.0278, 0.0274, 0.02695, 0.0265, 0.0261, 0.0257, 0.0253, 0.0249, 0.0245, 0.0241, 0.02375, 0.0234, 0.02305, 0.0227, 0.02235, 0.022, 0.02165, 0.0213, 0.021, 0.0207, 0.02035, 0.02, 0.01975, 0.0195, 0.0192, 0.0189, 0.0186, 0.0183, 0.01805, 0.0178, 0.01755, 0.0173, 0.01705, 0.0168, 0.01655, 0.0163, 0.01606, 0.01582, 0.01558, 0.01534, 0.0151, 0.0149, 0.0147, 0.0145, 0.0143, 0.0141, 0.0139, 0.0137, 0.0135, 0.0133, 0.0131, 0.01292, 0.01274, 0.01256, 0.01238, 0.0122, 0.01204, 0.01188, 0.01172, 0.01156, 0.0114, 0.01124, 0.01108, 0.01092, 0.01076, 0.0106, 0.01046, 0.01032, 0.01018, 0.01004, 0.0099, 0.00978, 0.00966, 0.00954, 0.00942, 0.0093, 0.00916, 0.00902, 0.00888, 0.00874, 0.0086, 0.0085, 0.0084, 0.0083, 0.0082, 0.0081, 0.00801, 0.00792, 0.00783, 0.00774, 0.00765, 0.00756, 0.00747, 0.00738, 0.00729, 0.0072, 0.00712, 0.00704, 0.00696, 0.00688, 0.0068, 0.00672, 0.00664, 0.00656, 0.00648, 0.0064, 0.00633, 0.00626, 0.00619, 0.00612, 0.00605, 0.00598, 0.00591, 0.00584, 0.00577, 0.0057, 0.00564, 0.00558, 0.00552, 0.00546, 0.0054, 0.00534, 0.00528, 0.00522, 0.00516, 0.0051, 0.00505, 0.005, 0.00495, 0.0049, 0.00485, 0.0048, 0.00475, 0.0047, 0.00465, 0.0046};

//SM Higgs ttH 
const double sigmaLHCHiggsttH8TeV[324]={321, 80, 400, 0.4277, 0.4152, 0.4032, 0.3915, 0.3803, 0.3694, 0.3589, 0.3487, 0.3389, 0.3294, 0.3202, 0.3113, 0.3027, 0.2944, 0.2864, 0.2786, 0.2711, 0.2638, 0.2567, 0.2499, 0.2433, 0.2369, 0.2308, 0.2248, 0.219, 0.2133, 0.2077, 0.2023, 0.1971, 0.192, 0.1871, 0.1824, 0.1779, 0.1735, 0.1692, 0.1651, 0.161, 0.1571, 0.1533, 0.1495, 0.1459, 0.1424, 0.139, 0.1356, 0.1324, 0.1293, 0.1262, 0.1233, 0.1204, 0.1176, 0.1149, 0.1123, 0.1097, 0.1072, 0.1048, 0.1024, 0.1001, 0.0979, 0.0957, 0.0936, 0.0915, 0.0895, 0.0875, 0.0856, 0.0838, 0.082, 0.0802, 0.0785, 0.0768, 0.0752, 0.0736, 0.07205, 0.0705, 0.06905, 0.0676, 0.06625, 0.0649, 0.0636, 0.0623, 0.06105, 0.0598, 0.0586, 0.0574, 0.0563, 0.0552, 0.0541, 0.053, 0.052, 0.051, 0.05, 0.049, 0.0481, 0.0472, 0.0463, 0.0454, 0.0446, 0.0438, 0.043, 0.0422, 0.0414, 0.0406, 0.03985, 0.0391, 0.0384, 0.0377, 0.037, 0.0364, 0.03575, 0.0351, 0.0345, 0.0339, 0.0333, 0.0327, 0.03215, 0.0316, 0.0311, 0.0306, 0.0301, 0.0296, 0.0291, 0.0286, 0.02815, 0.0277, 0.02725, 0.0268, 0.02635, 0.0259, 0.0255, 0.0251, 0.0247, 0.0243, 0.0239, 0.0235, 0.02315, 0.0228, 0.02245, 0.0221, 0.02175, 0.0214, 0.0211, 0.0208, 0.0205, 0.0202, 0.0199, 0.0196, 0.0193, 0.019, 0.01875, 0.0185, 0.01825, 0.018, 0.01775, 0.0175, 0.01725, 0.017, 0.01675, 0.0165, 0.01625, 0.016, 0.0158, 0.0156, 0.0154, 0.0152, 0.015, 0.0148, 0.0146, 0.0144, 0.0142, 0.014, 0.01385, 0.0137, 0.0135, 0.0133, 0.01315, 0.013, 0.01285, 0.0127, 0.01255, 0.0124, 0.01225, 0.0121, 0.01195, 0.0118, 0.01165, 0.0115, 0.01135, 0.0112, 0.0111, 0.011, 0.01085, 0.0107, 0.0106, 0.0105, 0.01035, 0.0102, 0.0101, 0.01, 0.0099, 0.0098, 0.00965, 0.0095, 0.0094, 0.0093, 0.0092, 0.0091, 0.009, 0.0089, 0.0088, 0.0087, 0.00865, 0.0086, 0.0085, 0.0084, 0.0083, 0.0082, 0.0081, 0.008, 0.00795, 0.0079, 0.0078, 0.0077, 0.00762, 0.00754, 0.00746, 0.00738, 0.0073, 0.00724, 0.00718, 0.00712, 0.00706, 0.007, 0.00694, 0.00688, 0.00682, 0.00676, 0.0067, 0.00664, 0.00658, 0.00652, 0.00646, 0.0064, 0.00634, 0.00628, 0.00622, 0.00616, 0.0061, 0.00604, 0.00598, 0.00592, 0.00586, 0.0058, 0.00576, 0.00572, 0.00568, 0.00564, 0.0056, 0.00554, 0.00548, 0.00542, 0.00536, 0.0053, 0.00526, 0.00522, 0.00518, 0.00514, 0.0051, 0.00506, 0.00502, 0.00498, 0.00494, 0.0049, 0.00486, 0.00482, 0.00478, 0.00474, 0.0047, 0.00466, 0.00462, 0.00458, 0.00454, 0.0045, 0.00447, 0.00444, 0.00441, 0.00438, 0.00435, 0.00432, 0.00429, 0.00426, 0.00423, 0.0042, 0.00417, 0.00414, 0.00411, 0.00408, 0.00405, 0.00402, 0.00399, 0.00396, 0.00393, 0.0039, 0.00387, 0.00384, 0.00381, 0.00378, 0.00375, 0.00372, 0.00369, 0.00366, 0.00363, 0.0036, 0.00358, 0.00356, 0.00354, 0.00352, 0.0035, 0.00348, 0.00346, 0.00344, 0.00342, 0.0034};


///// SM Higgs cross sections (in pb) at the LHC tables at 14 TeV as a function of mH in steps of 1 GeV (extracted from https://twiki.cern.ch/twiki/bin/view/LHCPhysics/CERNYellowReportPageAt14TeV)

//SM Higgs ggF 
const double sigmaLHCHiggsggF14TeV[914]={911, 90, 1000, 87.55, 86.006, 84.462, 82.918, 81.374, 79.83, 78.518, 77.206, 75.894, 74.582, 73.27, 72.084, 70.898, 69.712, 68.526, 67.34, 66.304, 65.268, 64.232, 63.196, 62.16, 61.242, 60.324, 59.406, 58.488, 57.57, 56.754, 55.938, 55.122, 54.306, 53.49, 52.762, 52.034, 51.306, 50.578, 49.85, 49.19, 48.53, 47.87, 47.21, 46.55, 45.962, 45.374, 44.786, 44.198, 43.61, 43.074, 42.538, 42.002, 41.466, 40.93, 40.442, 39.954, 39.466, 38.978, 38.49, 38.046, 37.602, 37.158, 36.714, 36.27, 35.86, 35.45, 35.04, 34.63, 34.22, 33.796, 33.372, 32.948, 32.524, 32.1, 31.634, 31.168, 30.702, 30.236, 29.77, 29.402, 29.034, 28.666, 28.298, 27.93, 27.616, 27.302, 26.988, 26.674, 26.36, 26.072, 25.784, 25.496, 25.208, 24.92, 24.634, 24.348, 24.062, 23.776, 23.49, 23.234, 22.978, 22.722, 22.466, 22.21, 21.988, 21.766, 21.544, 21.322, 21.1, 20.912, 20.724, 20.536, 20.348, 20.16, 19.993, 19.826, 19.659, 19.492, 19.325, 19.158, 18.991, 18.824, 18.657, 18.49, 18.349, 18.208, 18.067, 17.926, 17.785, 17.644, 17.503, 17.362, 17.221, 17.08, 16.958, 16.836, 16.714, 16.592, 16.47, 16.348, 16.226, 16.104, 15.982, 15.86, 15.756, 15.652, 15.548, 15.444, 15.34, 15.236, 15.132, 15.028, 14.924, 14.82, 14.73, 14.64, 14.55, 14.46, 14.37, 14.28, 14.19, 14.1, 14.01, 13.92, 13.842, 13.764, 13.686, 13.608, 13.53, 13.452, 13.374, 13.296, 13.218, 13.14, 13.073, 13.006, 12.939, 12.872, 12.805, 12.738, 12.671, 12.604, 12.537, 12.47, 12.413, 12.356, 12.299, 12.242, 12.185, 12.128, 12.071, 12.014, 11.957, 11.9, 11.853, 11.806, 11.759, 11.712, 11.665, 11.618, 11.571, 11.524, 11.477, 11.43, 11.392, 11.354, 11.316, 11.278, 11.24, 11.202, 11.164, 11.126, 11.088, 11.05, 11.027, 11.004, 10.981, 10.958, 10.935, 10.912, 10.889, 10.866, 10.843, 10.82, 10.797, 10.774, 10.751, 10.728, 10.705, 10.682, 10.659, 10.636, 10.613, 10.59, 10.5965, 10.603, 10.6095, 10.616, 10.6225, 10.629, 10.6355, 10.642, 10.6485, 10.655, 10.6615, 10.668, 10.6745, 10.681, 10.6875, 10.694, 10.7005, 10.707, 10.7135, 10.72, 10.7795, 10.839, 10.8985, 10.958, 11.0175, 11.077, 11.1365, 11.196, 11.2555, 11.315, 11.3745, 11.434, 11.4935, 11.553, 11.6125, 11.672, 11.7315, 11.791, 11.8505, 11.91, 11.9005, 11.891, 11.8815, 11.872, 11.8625, 11.853, 11.8435, 11.834, 11.8245, 11.815, 11.8055, 11.796, 11.7865, 11.777, 11.7675, 11.758, 11.7485, 11.739, 11.7295, 11.72, 11.6775, 11.635, 11.5925, 11.55, 11.5075, 11.465, 11.4225, 11.38, 11.3375, 11.295, 11.2525, 11.21, 11.1675, 11.125, 11.0825, 11.04, 10.9975, 10.955, 10.9125, 10.87, 10.8084, 10.7468, 10.6852, 10.6236, 10.562, 10.5004, 10.4388, 10.3772, 10.3156, 10.254, 10.1924, 10.1308, 10.0692, 10.0076, 9.946, 9.8844, 9.8228, 9.7612, 9.6996, 9.638, 9.5764, 9.5148, 9.4532, 9.3916, 9.33, 9.2684, 9.2068, 9.1452, 9.0836, 9.022, 8.9604, 8.8988, 8.8372, 8.7756, 8.714, 8.6524, 8.5908, 8.5292, 8.4676, 8.406, 8.3444, 8.2828, 8.2212, 8.1596, 8.098, 8.0364, 7.9748, 7.9132, 7.8516, 7.79, 7.7393, 7.6886, 7.6379, 7.5872, 7.5365, 7.4858, 7.4351, 7.3844, 7.3337, 7.283, 7.2323, 7.1816, 7.1309, 7.0802, 7.0295, 6.9788, 6.9281, 6.8774, 6.8267, 6.776, 6.7253, 6.6746, 6.6239, 6.5732, 6.5225, 6.4718, 6.4211, 6.3704, 6.3197, 6.269, 6.2183, 6.1676, 6.1169, 6.0662, 6.0155, 5.9648, 5.9141, 5.8634, 5.8127, 5.762, 5.7113, 5.6606, 5.6099, 5.5592, 5.5085, 5.4578, 5.4071, 5.3564, 5.3057, 5.255, 5.21976, 5.18452, 5.14928, 5.11404, 5.0788, 5.04356, 5.00832, 4.97308, 4.93784, 4.9026, 4.86736, 4.83212, 4.79688, 4.76164, 4.7264, 4.69116, 4.65592, 4.62068, 4.58544, 4.5502, 4.51496, 4.47972, 4.44448, 4.40924, 4.374, 4.33876, 4.30352, 4.26828, 4.23304, 4.1978, 4.16256, 4.12732, 4.09208, 4.05684, 4.0216, 3.98636, 3.95112, 3.91588, 3.88064, 3.8454, 3.81016, 3.77492, 3.73968, 3.70444, 3.6692, 3.63396, 3.59872, 3.56348, 3.52824, 3.493, 3.46978, 3.44656, 3.42334, 3.40012, 3.3769, 3.35368, 3.33046, 3.30724, 3.28402, 3.2608, 3.23758, 3.21436, 3.19114, 3.16792, 3.1447, 3.12148, 3.09826, 3.07504, 3.05182, 3.0286, 3.00538, 2.98216, 2.95894, 2.93572, 2.9125, 2.88928, 2.86606, 2.84284, 2.81962, 2.7964, 2.77318, 2.74996, 2.72674, 2.70352, 2.6803, 2.65708, 2.63386, 2.61064, 2.58742, 2.5642, 2.54098, 2.51776, 2.49454, 2.47132, 2.4481, 2.42488, 2.40166, 2.37844, 2.35522, 2.332, 2.31688, 2.30176, 2.28664, 2.27152, 2.2564, 2.24128, 2.22616, 2.21104, 2.19592, 2.1808, 2.16568, 2.15056, 2.13544, 2.12032, 2.1052, 2.09008, 2.07496, 2.05984, 2.04472, 2.0296, 2.01448, 1.99936, 1.98424, 1.96912, 1.954, 1.93888, 1.92376, 1.90864, 1.89352, 1.8784, 1.86328, 1.84816, 1.83304, 1.81792, 1.8028, 1.78768, 1.77256, 1.75744, 1.74232, 1.7272, 1.71208, 1.69696, 1.68184, 1.66672, 1.6516, 1.63648, 1.62136, 1.60624, 1.59112, 1.576, 1.56604, 1.55608, 1.54612, 1.53616, 1.5262, 1.51624, 1.50628, 1.49632, 1.48636, 1.4764, 1.46644, 1.45648, 1.44652, 1.43656, 1.4266, 1.41664, 1.40668, 1.39672, 1.38676, 1.3768, 1.36684, 1.35688, 1.34692, 1.33696, 1.327, 1.31704, 1.30708, 1.29712, 1.28716, 1.2772, 1.26724, 1.25728, 1.24732, 1.23736, 1.2274, 1.21744, 1.20748, 1.19752, 1.18756, 1.1776, 1.16764, 1.15768, 1.14772, 1.13776, 1.1278, 1.11784, 1.10788, 1.09792, 1.08796, 1.078, 1.07144, 1.06487, 1.05831, 1.05174, 1.04518, 1.03862, 1.03205, 1.02549, 1.01892, 1.01236, 1.0058, 0.999232, 0.992668, 0.986104, 0.97954, 0.972976, 0.966412, 0.959848, 0.953284, 0.94672, 0.940156, 0.933592, 0.927028, 0.920464, 0.9139, 0.907336, 0.900772, 0.894208, 0.887644, 0.88108, 0.874516, 0.867952, 0.861388, 0.854824, 0.84826, 0.841696, 0.835132, 0.828568, 0.822004, 0.81544, 0.808876, 0.802312, 0.795748, 0.789184, 0.78262, 0.776056, 0.769492, 0.762928, 0.756364, 0.7498, 0.745364, 0.740928, 0.736492, 0.732056, 0.72762, 0.723184, 0.718748, 0.714312, 0.709876, 0.70544, 0.701004, 0.696568, 0.692132, 0.687696, 0.68326, 0.678824, 0.674388, 0.669952, 0.665516, 0.66108, 0.656644, 0.652208, 0.647772, 0.643336, 0.6389, 0.634464, 0.630028, 0.625592, 0.621156, 0.61672, 0.612284, 0.607848, 0.603412, 0.598976, 0.59454, 0.590104, 0.585668, 0.581232, 0.576796, 0.57236, 0.567924, 0.563488, 0.559052, 0.554616, 0.55018, 0.545744, 0.541308, 0.536872, 0.532436, 0.528, 0.524972, 0.521944, 0.518916, 0.515888, 0.51286, 0.509832, 0.506804, 0.503776, 0.500748, 0.49772, 0.494692, 0.491664, 0.488636, 0.485608, 0.48258, 0.479552, 0.476524, 0.473496, 0.470468, 0.46744, 0.464412, 0.461384, 0.458356, 0.455328, 0.4523, 0.449272, 0.446244, 0.443216, 0.440188, 0.43716, 0.434132, 0.431104, 0.428076, 0.425048, 0.42202, 0.418992, 0.415964, 0.412936, 0.409908, 0.40688, 0.403852, 0.400824, 0.397796, 0.394768, 0.39174, 0.388712, 0.385684, 0.382656, 0.379628, 0.3766, 0.374514, 0.372428, 0.370342, 0.368256, 0.36617, 0.364084, 0.361998, 0.359912, 0.357826, 0.35574, 0.353654, 0.351568, 0.349482, 0.347396, 0.34531, 0.343224, 0.341138, 0.339052, 0.336966, 0.33488, 0.332794, 0.330708, 0.328622, 0.326536, 0.32445, 0.322364, 0.320278, 0.318192, 0.316106, 0.31402, 0.311934, 0.309848, 0.307762, 0.305676, 0.30359, 0.301504, 0.299418, 0.297332, 0.295246, 0.29316, 0.291074, 0.288988, 0.286902, 0.284816, 0.28273, 0.280644, 0.278558, 0.276472, 0.274386, 0.2723, 0.270828, 0.269356, 0.267884, 0.266412, 0.26494, 0.263468, 0.261996, 0.260524, 0.259052, 0.25758, 0.256108, 0.254636, 0.253164, 0.251692, 0.25022, 0.248748, 0.247276, 0.245804, 0.244332, 0.24286, 0.241388, 0.239916, 0.238444, 0.236972, 0.2355, 0.234028, 0.232556, 0.231084, 0.229612, 0.22814, 0.226668, 0.225196, 0.223724, 0.222252, 0.22078, 0.219308, 0.217836, 0.216364, 0.214892, 0.21342, 0.211948, 0.210476, 0.209004, 0.207532, 0.20606, 0.204588, 0.203116, 0.201644, 0.200172, 0.1987, 0.19767, 0.19664, 0.19561, 0.19458, 0.19355, 0.19252, 0.19149, 0.19046, 0.18943, 0.1884, 0.18737, 0.18634, 0.18531, 0.18428, 0.18325, 0.18222, 0.18119, 0.18016, 0.17913, 0.1781, 0.17707, 0.17604, 0.17501, 0.17398, 0.17295, 0.17192, 0.17089, 0.16986, 0.16883, 0.1678, 0.16677, 0.16574, 0.16471, 0.16368, 0.16265, 0.16162, 0.16059, 0.15956, 0.15853, 0.1575, 0.15647, 0.15544, 0.15441, 0.15338, 0.15235, 0.15132, 0.15029, 0.14926, 0.14823, 0.1472};

//SM Higgs VBF 
const double sigmaLHCHiggsVBF14TeV[914]={911, 90, 1000, 5.569, 5.5228, 5.4766, 5.4304, 5.3842, 5.338, 5.2932, 5.2484, 5.2036, 5.1588, 5.114, 5.0712, 5.0284, 4.9856, 4.9428, 4.9, 4.87, 4.84, 4.81, 4.78, 4.75, 4.704, 4.658, 4.612, 4.566, 4.52, 4.4882, 4.4564, 4.4246, 4.3928, 4.361, 4.3248, 4.2886, 4.2524, 4.2162, 4.18, 4.1498, 4.1196, 4.0894, 4.0592, 4.029, 3.9956, 3.9622, 3.9288, 3.8954, 3.862, 3.836, 3.81, 3.784, 3.758, 3.732, 3.7036, 3.6752, 3.6468, 3.6184, 3.59, 3.564, 3.538, 3.512, 3.486, 3.46, 3.4344, 3.4088, 3.3832, 3.3576, 3.332, 3.3052, 3.2784, 3.2516, 3.2248, 3.198, 3.1858, 3.1736, 3.1614, 3.1492, 3.137, 3.1162, 3.0954, 3.0746, 3.0538, 3.033, 3.0108, 2.9886, 2.9664, 2.9442, 2.922, 2.8986, 2.8752, 2.8518, 2.8284, 2.805, 2.792, 2.779, 2.766, 2.753, 2.74, 2.7224, 2.7048, 2.6872, 2.6696, 2.652, 2.6348, 2.6176, 2.6004, 2.5832, 2.566, 2.5472, 2.5284, 2.5096, 2.4908, 2.472, 2.4563, 2.4406, 2.4249, 2.4092, 2.3935, 2.3778, 2.3621, 2.3464, 2.3307, 2.315, 2.3006, 2.2862, 2.2718, 2.2574, 2.243, 2.2286, 2.2142, 2.1998, 2.1854, 2.171, 2.1575, 2.144, 2.1305, 2.117, 2.1035, 2.09, 2.0765, 2.063, 2.0495, 2.036, 2.0242, 2.0124, 2.0006, 1.9888, 1.977, 1.9652, 1.9534, 1.9416, 1.9298, 1.918, 1.9069, 1.8958, 1.8847, 1.8736, 1.8625, 1.8514, 1.8403, 1.8292, 1.8181, 1.807, 1.7974, 1.7878, 1.7782, 1.7686, 1.759, 1.7494, 1.7398, 1.7302, 1.7206, 1.711, 1.7005, 1.69, 1.6795, 1.669, 1.6585, 1.648, 1.6375, 1.627, 1.6165, 1.606, 1.5968, 1.5876, 1.5784, 1.5692, 1.56, 1.5508, 1.5416, 1.5324, 1.5232, 1.514, 1.5062, 1.4984, 1.4906, 1.4828, 1.475, 1.4672, 1.4594, 1.4516, 1.4438, 1.436, 1.4282, 1.4204, 1.4126, 1.4048, 1.397, 1.3892, 1.3814, 1.3736, 1.3658, 1.358, 1.3511, 1.3442, 1.3373, 1.3304, 1.3235, 1.3166, 1.3097, 1.3028, 1.2959, 1.289, 1.2821, 1.2752, 1.2683, 1.2614, 1.2545, 1.2476, 1.2407, 1.2338, 1.2269, 1.22, 1.2137, 1.2074, 1.2011, 1.1948, 1.1885, 1.1822, 1.1759, 1.1696, 1.1633, 1.157, 1.1507, 1.1444, 1.1381, 1.1318, 1.1255, 1.1192, 1.1129, 1.1066, 1.1003, 1.094, 1.08895, 1.0839, 1.07885, 1.0738, 1.06875, 1.0637, 1.05865, 1.0536, 1.04855, 1.0435, 1.03845, 1.0334, 1.02835, 1.0233, 1.01825, 1.0132, 1.00815, 1.0031, 0.99805, 0.993, 0.98909, 0.98518, 0.98127, 0.97736, 0.97345, 0.96954, 0.96563, 0.96172, 0.95781, 0.9539, 0.94999, 0.94608, 0.94217, 0.93826, 0.93435, 0.93044, 0.92653, 0.92262, 0.91871, 0.9148, 0.91117, 0.90754, 0.90391, 0.90028, 0.89665, 0.89302, 0.88939, 0.88576, 0.88213, 0.8785, 0.87487, 0.87124, 0.86761, 0.86398, 0.86035, 0.85672, 0.85309, 0.84946, 0.84583, 0.8422, 0.839142, 0.836084, 0.833026, 0.829968, 0.82691, 0.823852, 0.820794, 0.817736, 0.814678, 0.81162, 0.808562, 0.805504, 0.802446, 0.799388, 0.79633, 0.793272, 0.790214, 0.787156, 0.784098, 0.78104, 0.777982, 0.774924, 0.771866, 0.768808, 0.76575, 0.762692, 0.759634, 0.756576, 0.753518, 0.75046, 0.747402, 0.744344, 0.741286, 0.738228, 0.73517, 0.732112, 0.729054, 0.725996, 0.722938, 0.71988, 0.716822, 0.713764, 0.710706, 0.707648, 0.70459, 0.701532, 0.698474, 0.695416, 0.692358, 0.6893, 0.686882, 0.684464, 0.682046, 0.679628, 0.67721, 0.674792, 0.672374, 0.669956, 0.667538, 0.66512, 0.662702, 0.660284, 0.657866, 0.655448, 0.65303, 0.650612, 0.648194, 0.645776, 0.643358, 0.64094, 0.638522, 0.636104, 0.633686, 0.631268, 0.62885, 0.626432, 0.624014, 0.621596, 0.619178, 0.61676, 0.614342, 0.611924, 0.609506, 0.607088, 0.60467, 0.602252, 0.599834, 0.597416, 0.594998, 0.59258, 0.590162, 0.587744, 0.585326, 0.582908, 0.58049, 0.578072, 0.575654, 0.573236, 0.570818, 0.5684, 0.56648, 0.56456, 0.56264, 0.56072, 0.5588, 0.55688, 0.55496, 0.55304, 0.55112, 0.5492, 0.54728, 0.54536, 0.54344, 0.54152, 0.5396, 0.53768, 0.53576, 0.53384, 0.53192, 0.53, 0.52808, 0.52616, 0.52424, 0.52232, 0.5204, 0.51848, 0.51656, 0.51464, 0.51272, 0.5108, 0.50888, 0.50696, 0.50504, 0.50312, 0.5012, 0.49928, 0.49736, 0.49544, 0.49352, 0.4916, 0.48968, 0.48776, 0.48584, 0.48392, 0.482, 0.48008, 0.47816, 0.47624, 0.47432, 0.4724, 0.470882, 0.469364, 0.467846, 0.466328, 0.46481, 0.463292, 0.461774, 0.460256, 0.458738, 0.45722, 0.455702, 0.454184, 0.452666, 0.451148, 0.44963, 0.448112, 0.446594, 0.445076, 0.443558, 0.44204, 0.440522, 0.439004, 0.437486, 0.435968, 0.43445, 0.432932, 0.431414, 0.429896, 0.428378, 0.42686, 0.425342, 0.423824, 0.422306, 0.420788, 0.41927, 0.417752, 0.416234, 0.414716, 0.413198, 0.41168, 0.410162, 0.408644, 0.407126, 0.405608, 0.40409, 0.402572, 0.401054, 0.399536, 0.398018, 0.3965, 0.39529, 0.39408, 0.39287, 0.39166, 0.39045, 0.38924, 0.38803, 0.38682, 0.38561, 0.3844, 0.38319, 0.38198, 0.38077, 0.37956, 0.37835, 0.37714, 0.37593, 0.37472, 0.37351, 0.3723, 0.37109, 0.36988, 0.36867, 0.36746, 0.36625, 0.36504, 0.36383, 0.36262, 0.36141, 0.3602, 0.35899, 0.35778, 0.35657, 0.35536, 0.35415, 0.35294, 0.35173, 0.35052, 0.34931, 0.3481, 0.34689, 0.34568, 0.34447, 0.34326, 0.34205, 0.34084, 0.33963, 0.33842, 0.33721, 0.336, 0.335024, 0.334048, 0.333072, 0.332096, 0.33112, 0.330144, 0.329168, 0.328192, 0.327216, 0.32624, 0.325264, 0.324288, 0.323312, 0.322336, 0.32136, 0.320384, 0.319408, 0.318432, 0.317456, 0.31648, 0.315504, 0.314528, 0.313552, 0.312576, 0.3116, 0.310624, 0.309648, 0.308672, 0.307696, 0.30672, 0.305744, 0.304768, 0.303792, 0.302816, 0.30184, 0.300864, 0.299888, 0.298912, 0.297936, 0.29696, 0.295984, 0.295008, 0.294032, 0.293056, 0.29208, 0.291104, 0.290128, 0.289152, 0.288176, 0.2872, 0.286408, 0.285616, 0.284824, 0.284032, 0.28324, 0.282448, 0.281656, 0.280864, 0.280072, 0.27928, 0.278488, 0.277696, 0.276904, 0.276112, 0.27532, 0.274528, 0.273736, 0.272944, 0.272152, 0.27136, 0.270568, 0.269776, 0.268984, 0.268192, 0.2674, 0.266608, 0.265816, 0.265024, 0.264232, 0.26344, 0.262648, 0.261856, 0.261064, 0.260272, 0.25948, 0.258688, 0.257896, 0.257104, 0.256312, 0.25552, 0.254728, 0.253936, 0.253144, 0.252352, 0.25156, 0.250768, 0.249976, 0.249184, 0.248392, 0.2476, 0.246958, 0.246316, 0.245674, 0.245032, 0.24439, 0.243748, 0.243106, 0.242464, 0.241822, 0.24118, 0.240538, 0.239896, 0.239254, 0.238612, 0.23797, 0.237328, 0.236686, 0.236044, 0.235402, 0.23476, 0.234118, 0.233476, 0.232834, 0.232192, 0.23155, 0.230908, 0.230266, 0.229624, 0.228982, 0.22834, 0.227698, 0.227056, 0.226414, 0.225772, 0.22513, 0.224488, 0.223846, 0.223204, 0.222562, 0.22192, 0.221278, 0.220636, 0.219994, 0.219352, 0.21871, 0.218068, 0.217426, 0.216784, 0.216142, 0.2155, 0.21496, 0.21442, 0.21388, 0.21334, 0.2128, 0.21226, 0.21172, 0.21118, 0.21064, 0.2101, 0.20956, 0.20902, 0.20848, 0.20794, 0.2074, 0.20686, 0.20632, 0.20578, 0.20524, 0.2047, 0.20416, 0.20362, 0.20308, 0.20254, 0.202, 0.20146, 0.20092, 0.20038, 0.19984, 0.1993, 0.19876, 0.19822, 0.19768, 0.19714, 0.1966, 0.19606, 0.19552, 0.19498, 0.19444, 0.1939, 0.19336, 0.19282, 0.19228, 0.19174, 0.1912, 0.19066, 0.19012, 0.18958, 0.18904, 0.1885, 0.188062, 0.187624, 0.187186, 0.186748, 0.18631, 0.185872, 0.185434, 0.184996, 0.184558, 0.18412, 0.183682, 0.183244, 0.182806, 0.182368, 0.18193, 0.181492, 0.181054, 0.180616, 0.180178, 0.17974, 0.179302, 0.178864, 0.178426, 0.177988, 0.17755, 0.177112, 0.176674, 0.176236, 0.175798, 0.17536, 0.174922, 0.174484, 0.174046, 0.173608, 0.17317, 0.172732, 0.172294, 0.171856, 0.171418, 0.17098, 0.170542, 0.170104, 0.169666, 0.169228, 0.16879, 0.168352, 0.167914, 0.167476, 0.167038, 0.1666, 0.166236, 0.165872, 0.165508, 0.165144, 0.16478, 0.164416, 0.164052, 0.163688, 0.163324, 0.16296, 0.162596, 0.162232, 0.161868, 0.161504, 0.16114, 0.160776, 0.160412, 0.160048, 0.159684, 0.15932, 0.158956, 0.158592, 0.158228, 0.157864, 0.1575, 0.157136, 0.156772, 0.156408, 0.156044, 0.15568, 0.155316, 0.154952, 0.154588, 0.154224, 0.15386, 0.153496, 0.153132, 0.152768, 0.152404, 0.15204, 0.151676, 0.151312, 0.150948, 0.150584, 0.15022, 0.149856, 0.149492, 0.149128, 0.148764, 0.1484, 0.148092, 0.147784, 0.147476, 0.147168, 0.14686, 0.146552, 0.146244, 0.145936, 0.145628, 0.14532, 0.145012, 0.144704, 0.144396, 0.144088, 0.14378, 0.143472, 0.143164, 0.142856, 0.142548, 0.14224, 0.141932, 0.141624, 0.141316, 0.141008, 0.1407, 0.140392, 0.140084, 0.139776, 0.139468, 0.13916, 0.138852, 0.138544, 0.138236, 0.137928, 0.13762, 0.137312, 0.137004, 0.136696, 0.136388, 0.13608, 0.135772, 0.135464, 0.135156, 0.134848, 0.13454, 0.134232, 0.133924, 0.133616, 0.133308, 0.133};

//SM Higgs WH 
const double sigmaLHCHiggsWH14TeV[214]={211, 90, 300, 4.09, 3.9718, 3.8536, 3.7354, 3.6172, 3.499, 3.3996, 3.3002, 3.2008, 3.1014, 3.002, 2.9208, 2.8396, 2.7584, 2.6772, 2.596, 2.526, 2.456, 2.386, 2.316, 2.246, 2.1872, 2.1284, 2.0696, 2.0108, 1.952, 1.9036, 1.8552, 1.8068, 1.7584, 1.71, 1.6688, 1.6276, 1.5864, 1.5452, 1.504, 1.468, 1.432, 1.396, 1.36, 1.324, 1.2926, 1.2612, 1.2298, 1.1984, 1.167, 1.1404, 1.1138, 1.0872, 1.0606, 1.034, 1.0112, 0.9884, 0.9656, 0.9428, 0.92, 0.89912, 0.87824, 0.85736, 0.83648, 0.8156, 0.79758, 0.77956, 0.76154, 0.74352, 0.7255, 0.70722, 0.68894, 0.67066, 0.65238, 0.6341, 0.62428, 0.61446, 0.60464, 0.59482, 0.585, 0.5732, 0.5614, 0.5496, 0.5378, 0.526, 0.51606, 0.50612, 0.49618, 0.48624, 0.4763, 0.46652, 0.45674, 0.44696, 0.43718, 0.4274, 0.42118, 0.41496, 0.40874, 0.40252, 0.3963, 0.38904, 0.38178, 0.37452, 0.36726, 0.36, 0.35382, 0.34764, 0.34146, 0.33528, 0.3291, 0.32336, 0.31762, 0.31188, 0.30614, 0.3004, 0.29562, 0.29084, 0.28606, 0.28128, 0.2765, 0.27172, 0.26694, 0.26216, 0.25738, 0.2526, 0.24872, 0.24484, 0.24096, 0.23708, 0.2332, 0.22932, 0.22544, 0.22156, 0.21768, 0.2138, 0.21068, 0.20756, 0.20444, 0.20132, 0.1982, 0.19508, 0.19196, 0.18884, 0.18572, 0.1826, 0.17995, 0.1773, 0.17465, 0.172, 0.16935, 0.1667, 0.16405, 0.1614, 0.15875, 0.1561, 0.15392, 0.15174, 0.14956, 0.14738, 0.1452, 0.14302, 0.14084, 0.13866, 0.13648, 0.1343, 0.13248, 0.13066, 0.12884, 0.12702, 0.1252, 0.12338, 0.12156, 0.11974, 0.11792, 0.1161, 0.11458, 0.11306, 0.11154, 0.11002, 0.1085, 0.10698, 0.10546, 0.10394, 0.10242, 0.1009, 0.09959, 0.09828, 0.09697, 0.09566, 0.09435, 0.09304, 0.09173, 0.09042, 0.08911, 0.0878, 0.08673, 0.08566, 0.08459, 0.08352, 0.08245, 0.08138, 0.08031, 0.07924, 0.07817, 0.0771, 0.07615, 0.0752, 0.07425, 0.0733, 0.07235, 0.0714, 0.07045, 0.0695, 0.06855, 0.0676};

//SM Higgs ZH 
const double sigmaLHCHiggsZH14TeV[214]={211, 90, 300,2.245, 2.1842, 2.1234, 2.0626, 2.0018, 1.941, 1.8894, 1.8378, 1.7862, 1.7346, 1.683, 1.64, 1.597, 1.554, 1.511, 1.468, 1.431, 1.394, 1.357, 1.32, 1.283, 1.2524, 1.2218, 1.1912, 1.1606, 1.13, 1.10334, 1.07668, 1.05002, 1.02336, 0.9967, 0.97396, 0.95122, 0.92848, 0.90574, 0.883, 0.86332, 0.84364, 0.82396, 0.80428, 0.7846, 0.7673, 0.75, 0.7327, 0.7154, 0.6981, 0.6836, 0.6691, 0.6546, 0.6401, 0.6256, 0.6125, 0.5994, 0.5863, 0.5732, 0.5601, 0.5484, 0.5367, 0.525, 0.5133, 0.5016, 0.49154, 0.48148, 0.47142, 0.46136, 0.4513, 0.44076, 0.43022, 0.41968, 0.40914, 0.3986, 0.39298, 0.38736, 0.38174, 0.37612, 0.3705, 0.3635, 0.3565, 0.3495, 0.3425, 0.3355, 0.32928, 0.32306, 0.31684, 0.31062, 0.3044, 0.2984, 0.2924, 0.2864, 0.2804, 0.2744, 0.27, 0.2656, 0.2612, 0.2568, 0.2524, 0.24794, 0.24348, 0.23902, 0.23456, 0.2301, 0.22632, 0.22254, 0.21876, 0.21498, 0.2112, 0.20768, 0.20416, 0.20064, 0.19712, 0.1936, 0.19052, 0.18744, 0.18436, 0.18128, 0.1782, 0.17512, 0.17204, 0.16896, 0.16588, 0.1628, 0.16032, 0.15784, 0.15536, 0.15288, 0.1504, 0.14792, 0.14544, 0.14296, 0.14048, 0.138, 0.13593, 0.13386, 0.13179, 0.12972, 0.12765, 0.12558, 0.12351, 0.12144, 0.11937, 0.1173, 0.11557, 0.11384, 0.11211, 0.11038, 0.10865, 0.10692, 0.10519, 0.10346, 0.10173, 0.1, 0.09854, 0.09708, 0.09562, 0.09416, 0.0927, 0.09124, 0.08978, 0.08832, 0.08686, 0.0854, 0.0842, 0.083, 0.0818, 0.0806, 0.0794, 0.0782, 0.077, 0.0758, 0.0746, 0.0734, 0.07239, 0.07138, 0.07037, 0.06936, 0.06835, 0.06734, 0.06633, 0.06532, 0.06431, 0.0633, 0.06244, 0.06158, 0.06072, 0.05986, 0.059, 0.05814, 0.05728, 0.05642, 0.05556, 0.0547, 0.054, 0.0533, 0.0526, 0.0519, 0.0512, 0.0505, 0.0498, 0.0491, 0.0484, 0.0477, 0.04709, 0.04648, 0.04587, 0.04526, 0.04465, 0.04404, 0.04343, 0.04282, 0.04221, 0.0416};

//SM Higgs ttH 
const double sigmaLHCHiggsttH14TeV[214]={211, 90, 300,1.449, 1.4128, 1.3766, 1.3404, 1.3042, 1.268, 1.2372, 1.2064, 1.1756, 1.1448, 1.114, 1.08752, 1.06104, 1.03456, 1.00808, 0.9816, 0.9589, 0.9362, 0.9135, 0.8908, 0.8681, 0.84846, 0.82882, 0.80918, 0.78954, 0.7699, 0.75292, 0.73594, 0.71896, 0.70198, 0.685, 0.67026, 0.65552, 0.64078, 0.62604, 0.6113, 0.59848, 0.58566, 0.57284, 0.56002, 0.5472, 0.53596, 0.52472, 0.51348, 0.50224, 0.491, 0.48118, 0.47136, 0.46154, 0.45172, 0.4419, 0.4333, 0.4247, 0.4161, 0.4075, 0.3989, 0.3913, 0.3837, 0.3761, 0.3685, 0.3609, 0.35422, 0.34754, 0.34086, 0.33418, 0.3275, 0.3216, 0.3157, 0.3098, 0.3039, 0.298, 0.29276, 0.28752, 0.28228, 0.27704, 0.2718, 0.26718, 0.26256, 0.25794, 0.25332, 0.2487, 0.24454, 0.24038, 0.23622, 0.23206, 0.2279, 0.22422, 0.22054, 0.21686, 0.21318, 0.2095, 0.2062, 0.2029, 0.1996, 0.1963, 0.193, 0.19006, 0.18712, 0.18418, 0.18124, 0.1783, 0.17564, 0.17298, 0.17032, 0.16766, 0.165, 0.16264, 0.16028, 0.15792, 0.15556, 0.1532, 0.15117, 0.14914, 0.14711, 0.14508, 0.14305, 0.14102, 0.13899, 0.13696, 0.13493, 0.1329, 0.13123, 0.12956, 0.12789, 0.12622, 0.12455, 0.12288, 0.12121, 0.11954, 0.11787, 0.1162, 0.11483, 0.11346, 0.11209, 0.11072, 0.10935, 0.10798, 0.10661, 0.10524, 0.10387, 0.1025, 0.10136, 0.10022, 0.09908, 0.09794, 0.0968, 0.09566, 0.09452, 0.09338, 0.09224, 0.0911, 0.09015, 0.0892, 0.08825, 0.0873, 0.08635, 0.0854, 0.08445, 0.0835, 0.08255, 0.0816, 0.08079, 0.07998, 0.07917, 0.07836, 0.07755, 0.07674, 0.07593, 0.07512, 0.07431, 0.0735, 0.07282, 0.07214, 0.07146, 0.07078, 0.0701, 0.06942, 0.06874, 0.06806, 0.06738, 0.0667, 0.06611, 0.06552, 0.06493, 0.06434, 0.06375, 0.06316, 0.06257, 0.06198, 0.06139, 0.0608, 0.0603, 0.0598, 0.0593, 0.0588, 0.0583, 0.0578, 0.0573, 0.0568, 0.0563, 0.0558, 0.05535, 0.0549, 0.05445, 0.054, 0.05355, 0.0531, 0.05265, 0.0522, 0.05175, 0.0513};








  //Limits H->bb on (sigma_New/sigma_SM)*Br(H_i->bb)/ mass in [12:116] in steps of 2
const double LEPbb[56]= {53,12,116,0.0154, 0.0143, 0.0134, 0.0131, 0.0139, 0.0156, 0.0174, 0.0186, 0.0195, 0.0181, 0.0173, 0.0172, 0.0187, 0.0235, 0.0267,0.0297,0.031,0.0328,0.0337,0.0316,0.0344,0.0349,0.036,0.0367,0.0365,0.0264,0.0258,0.0218,0.0218,0.0246,0.0274,0.0301,0.038,0.0424, 0.041,0.0475,0.0585,0.0816,0.118,0.152,0.175,0.214,0.22,0.233,0.216,0.216,0.227,0.223,0.227,0.244,0.343,0.64,1.79};

  //Br(H_i->bb) mass in [12:116] in steps of 2
 
const double Brbb[56]= {53,12,116,0.807837, 0.831298, 0.842424, 0.848434, 0.851893, 0.85392, 0.855073, 0.855655, 0.855842, 0.855745, 0.855432, 0.85495, 0.85433, 
0.853594, 0.852758, 0.851833, 0.850827, 0.849746, 0.848595, 0.847376, 0.846094, 0.844748, 0.843341, 0.841874, 0.840347, 0.83876,0.837113,0.835406,0.833639,
0.831809,0.829918,0.827961,0.825938,0.823846,0.821681,0.819437,0.817105,0.814668,0.812095,0.809339,0.806331, 0.802982,0.799179,0.794784,0.789637,0.783556,
0.77634,0.767773,0.757631,0.745692,0.731743,0.715596,0.697101};

  //Width of the SM Higgs, binned in mass from 0 in steps of 5.
const double WidthSM[144]={141,0,600,0,0.0000133516, 0.000145963, 0.000364235, 0.000529872, 0.000671898, 0.000801917, 0.000925042, 0.00104391, 0.00116005, 0.00127448, 0.00138792, 0.0015009, 0.00161388, 0.00172726, 0.00184143, 0.00195679, 0.00207386, 0.00219375, 0.00231943, 0.00245714, 0.00261796, 0.00281963, 0.00308912, 
0.00346666, 0.0040126, 0.00481989, 0.00603898, 0.00793241, 0.0110145, 0.0164976, 0.0283839, 0.0744118, 0.247254, 0.380736, 0.498005, 0.624421, 0.823484, 
1.03155, 1.22337, 1.41601, 1.61525, 1.82415, 2.0447, 2.2783, 2.52608, 2.78894, 3.06765, 3.36289, 3.67526, 4.00533, 4.35361, 4.72058, 5.10672, 5.51247, 5.93827, 6.38452, 6.85164, 7.34004, 7.85011, 8.38224, 8.93682, 9.51424, 10.1149, 10.7391, 11.3874, 12.06, 12.7573, 13.4799, 14.2282, 15.1006, 16.0754, 17.1216, 18.2279, 19.3875, 20.5958, 21.8496, 23.1465, 24.4846, 25.8624, 27.2787, 28.7327, 30.2235,31.7507, 33.3138, 34.9124, 36.5462, 38.2152, 39.9192, 41.658, 43.4319, 45.2406, 47.0844, 48.9634, 50.8776, 52.8272, 54.8124, 56.8335, 58.8905, 60.9839, 63.1137, 65.2803, 67.484, 69.7249, 72.0035, 74.32, 76.6747, 79.068, 81.5001, 83.9714, 86.4822, 89.0329, 91.6238, 94.2552, 96.9274, 99.6409, 102.396, 105.193, 108.032, 110.914, 113.839, 116.808, 119.82, 122.876, 125.977, 129.122, 132.313, 135.549, 138.832, 142.16, 145.536, 148.958, 152.428, 155.946, 159.511, 163.126, 166.789, 170.502, 174.265, 178.077, 181.94};

  //Limits H->tautau on (sigma_New/sigma_SM)*Br(H_i->tautau)/ mass in [12:116] in steps of 2
const double LEPtau[56]= {53,12,116,0.0925, 0.0899, 0.0923, 0.0933, 0.106, 0.108, 0.111, 0.114, 0.111, 0.0893, 0.0796, 0.0682, 0.0653, 0.0634, 0.0615,0.0599,0.0594,0.0572,0.0575,0.0445,0.0454,0.0464,0.0403,0.0427,0.0456,0.0444,0.0394,0.0287,0.0287,0.0287,0.0271,0.0297,0.0351,0.035,0.0316,0.0281,0.0222,0.0257,0.0296,0.0331,0.0354,0.0491,0.057,0.0565,0.0582,0.0588,0.0704,0.0896,0.11,0.144,0.212,0.41,1.79};

  //Br(H_i->bb) mass in [12:116] in steps of 2
const double Brtau[56]={53,12,116,0.0893602, 0.0804905, 0.0767905, 0.0751745, 0.0745504, 0.0744461, 0.0746294, 0.0749763, 0.075416, 0.0759064, 0.0764213,0.0769444,0.0774651,0.0779766,0.0784746,0.0789561,0.0794195,0.0798635,0.0802877,0.0806919,0.0810759,0.08144,0.0817842,0.082109,
0.0824147,0.0827015,0.0829698,0.0832198,0.083452,0.0836665,0.0838636,0.0840434,0.084206,0.0843514,0.0844796,0.0845902,0.0846825,0.084755,
0.0848047,0.0848266,0.0848138,0.0847568,0.0846435,0.084459,0.0841861,0.0838047,0.0832926,0.0826256,0.0817786,0.0807262,0.0794442,0.0779104,
		       0.0761068};

//mu Atlas combined multi-Channel from 110 to 600 GeV in steps of 1 GeV (extracted from arXiv:1202.1408)
const double muATLAS7TeV[494]={491,110,600,1.168, 1.045, 0.8958, 0.7398, 0.6499, 0.654, 0.8319, 1.085, 1.197, 1.05, 0.8794, 0.8166, 0.9646, 1.289, 1.551, 1.712, 1.766, 1.6, 1.321,1.045, 0.8066, 0.6828, 0.6148, 0.5502, 0.5047, 0.4516, 0.4299, 0.4325, 0.46, 0.4715, 0.4194, 0.4142, 0.4016, 0.4272, 0.4461, 0.4488, 0.4272, 0.4066, 0.373, 0.3421, 0.31, 0.2959, 0.2818, 0.27525, 0.2687, 0.26555, 0.2624, 0.25635, 0.2503, 0.2312, 0.2121, 0.20195, 0.1918, 0.19065, 0.1895, 0.18145, 0.1734, 0.17495, 0.1765, 0.18135, 0.1862, 0.1907, 0.1952, 0.19815, 0.2011, 0.2041, 0.2071, 0.2077, 0.2083, 0.20955, 0.2108, 0.21855, 0.2263, 0.23395, 0.2416, 0.24745, 0.2533, 0.2563, 0.2593, 0.26245, 0.2656, 0.2656, 0.2656, 0.2656, 0.2656, 0.2952, 0.3248, 0.3452, 0.3656, 0.38495, 0.4043, 0.42045, 0.4366, 0.46995, 0.5033, 0.5283, 0.5533, 0.5616, 0.5699, 0.5767, 0.5835, 0.575, 0.5665, 0.5379, 0.5093, 0.48765, 0.466, 0.44245, 0.4189, 0.4189, 0.4189, 0.4128, 0.4067, 0.40075, 0.3948, 0.39955, 0.4043, 0.4079, 0.4115, 0.43465, 0.4578, 0.47905, 0.5003, 0.5351, 0.5699, 0.5982, 0.6265, 0.6417, 0.6569, 0.6708, 0.6847, 0.69705, 0.7094, 0.7073, 0.7052, 0.6889, 0.6726, 0.64955, 0.6265, 0.61915, 0.6118, 0.56055, 0.5093, 0.4918, 0.4743, 0.44535, 0.4164, 0.41035, 0.4043, 0.4067, 0.4091, 0.41525, 0.4214, 0.42515, 0.4289, 0.4516, 0.4743, 0.4829, 0.4915, 0.5159, 0.5403, 0.5387, 0.5371, 0.5371, 0.5371, 0.5371, 0.5371, 0.5371, 0.5371, 0.5403, 0.5435, 0.53405, 0.5246, 0.51395, 0.5033, 0.4974, 0.4915, 0.48575, 0.48, 0.473, 0.466, 0.4619, 0.4578, 0.4485, 0.4392, 0.4328, 0.4264, 0.4083, 0.3902, 0.3594, 0.3286, 0.32632, 0.32404, 0.32176, 0.31948, 0.3172, 0.32106, 0.32492, 0.32878, 0.33264, 0.3365, 0.34406, 0.35162, 0.35918, 0.36674, 0.3743, 0.38078, 0.38726, 0.39374, 0.40022, 0.4067, 0.40622, 0.40574, 0.40526, 0.40478, 0.4043, 0.40334, 0.40238, 0.40142, 0.40046, 0.3995, 0.39272, 0.38594, 0.37916, 0.37238, 0.3656, 0.35406, 0.34252, 0.33098, 0.31944, 0.3079, 0.30038, 0.29286, 0.28534, 0.27782, 0.2703, 0.26456, 0.25882, 0.25308, 0.24734, 0.2416, 0.23722, 0.23284, 0.22846, 0.22408, 0.2197, 0.21504, 0.21038, 0.20572, 0.20106, 0.1964, 0.19458, 0.19276, 0.19094, 0.18912, 0.1873, 0.18472, 0.18214, 0.17956, 0.17698, 0.1744, 0.1732, 0.172, 0.1708, 0.1696, 0.1684, 0.16646, 0.16452, 0.16258, 0.16064, 0.1587, 0.15888, 0.15906, 0.15924, 0.15942, 0.1596, 0.15922, 0.15884, 0.15846, 0.15808, 0.1577, 0.15808, 0.15846, 0.15884, 0.15922, 0.1596, 0.16076, 0.16192, 0.16308, 0.16424, 0.1654, 0.16784, 0.17028, 0.17272, 0.17516, 0.1776, 0.18044, 0.18328, 0.18612, 0.18896, 0.1918, 0.19462, 0.19744, 0.20026, 0.20308, 0.2059, 0.20952, 0.21314, 0.21676, 0.22038, 0.224, 0.22838, 0.23276, 0.23714, 0.24152, 0.2459, 0.25208, 0.25826, 0.26444, 0.27062, 0.2768, 0.28158, 0.28636, 0.29114, 0.29592, 0.3007, 0.30866, 0.31662, 0.32458, 0.33254, 0.3405, 0.34726, 0.35402, 0.36078, 0.36754, 0.3743, 0.38126, 0.38822, 0.39518, 0.40214, 0.4091, 0.41776, 0.42642, 0.43508, 0.44374, 0.4524, 0.46438, 0.47636, 0.48834, 0.50032, 0.5123, 0.516, 0.5197, 0.5234, 0.5271, 0.5308, 0.5353, 0.5398, 0.5443, 0.5488, 0.5533, 0.55866, 0.56402, 0.56938, 0.57474, 0.5801, 0.58288, 0.58566, 0.58844, 0.59122, 0.594, 0.5983, 0.6026, 0.6069, 0.6112, 0.6155, 0.6192, 0.6229, 0.6266, 0.6303, 0.634, 0.6378, 0.6416, 0.6454, 0.6492, 0.653, 0.65934, 0.66568, 0.67202, 0.67836, 0.6847, 0.68798, 0.69126, 0.69454, 0.69782, 0.7011, 0.70446, 0.70782, 0.71118, 0.71454, 0.7179, 0.72134, 0.72478, 0.72822, 0.73166, 0.7351, 0.7351, 0.7351, 0.7351, 0.7351, 0.7351, 0.74592, 0.75674, 0.76756, 0.77838, 0.7892, 0.79982, 0.81044, 0.82106, 0.83168, 0.8423, 0.85794, 0.87358, 0.88922, 0.90486, 0.9205, 0.93288, 0.94526, 0.95764, 0.97002, 0.9824, 0.98952, 0.99664, 1.00376, 1.01088, 1.018, 1.0316, 1.0452, 1.0588, 1.0724, 1.086, 1.0966, 1.1072, 1.1178, 1.1284, 1.139, 1.1514, 1.1638, 1.1762, 1.1886, 1.201, 1.2142, 1.2274, 1.2406, 1.2538, 1.267, 1.2808, 1.2946, 1.3084, 1.3222, 1.336, 1.3592, 1.3824, 1.4056, 1.4288, 1.452, 1.4716, 1.4912, 1.5108, 1.5304, 1.55, 1.565, 1.58, 1.595, 1.61, 1.625, 1.6368, 1.6486, 1.6604, 1.6722, 1.684, 1.694, 1.704, 1.714, 1.724, 1.734, 1.7466, 1.7592, 1.7718, 1.7844, 1.797};

//mu Atlas combined multi-Channel from 110 to 600 GeV in steps of 1 GeV (extracted from arXiv:1207.7214)
const double muATLAS7and8TeV[494]={491,110,600,1.00183, 0.95918, 0.797668, 0.653359, 0.678032, 0.787864, 0.811738,0.798645, 0.776936, 0.73186, 0.698317, 0.699098, 0.750296, 0.879532, 0.988681, 1.29529, 1.55463, 1.66134, 1.62457, 1.44937, 1.19818, 1.00248, 0.782919, 0.660198, 0.571884, 0.543767, 0.505298, 0.456008, 0.403199, 0.379306, 0.385971, 0.387642, 0.377661, 0.367681, 0.357701, 0.34772, 0.329111, 0.310083, 0.307211, 0.304339, 0.316281, 0.309129, 0.300162, 0.290675, 0.28454, 0.27901, 0.272149, 0.262054, 0.25196, 0.238868, 0.224642, 0.214214, 0.204132, 0.194606, 0.184928, 0.175241, 0.173214, 0.172267, 0.17394, 0.175613, 0.177135, 0.177854, 0.178574, 0.180283, 0.182454, 0.184475, 0.185753, 0.187031, 0.190405, 0.200005, 0.204986, 0.200169, 0.188321, 0.17864, 0.171884, 0.1667, 0.164156,0.175564, 0.196678, 0.218665, 0.236191, 0.257082, 0.272994, 0.28501, 0.292338, 0.317285, 0.339632, 0.340596, 0.332303, 0.328149, 0.326002, 0.307287, 0.292673, 0.285754, 0.285006, 0.287265, 0.292058, 0.313356,  0.342711, 0.392116, 0.419017, 0.419017, 0.41875, 0.415584, 0.405445, 0.38491, 0.355959, 0.346236, 0.335051, 0.320592, 0.285847, 0.274969, 0.264091, 0.25422, 0.246718, 0.239215, 0.237096, 0.235068, 0.233816, 0.232994, 0.232171, 0.23822, 0.245937, 0.253654, 0.261371, 0.268313, 0.275435, 0.293107, 0.3137, 0.336679, 0.351791, 0.361152, 0.370512, 0.378318, 0.369561, 0.360803, 0.347347, 0.309635, 0.29117, 0.272705, 0.261583, 0.250604, 0.246193, 0.251971, 0.257749, 0.268471, 0.280619, 0.292766, 0.306335, 0.339266, 0.364383, 0.380436, 0.395596, 0.410594, 0.425593, 0.44631, 0.471066, 0.468562, 0.464321, 0.461663, 0.459591, 0.445556, 0.419593, 0.409092, 0.402056, 0.39502, 0.387985, 0.374122, 0.346904, 0.350957, 0.359275, 0.374027, 0.380796, 0.383419, 0.386043, 0.394976, 0.406203, 0.395441, 0.383852, 0.392599, 0.411149, 0.422736, 0.423413, 0.416476, 0.408269, 0.393763, 0.379256, 0.35986, 0.338624, 0.307936, 0.299258, 0.29058, 0.281902, 0.276112, 0.272838, 0.269681, 0.271835, 0.273989, 0.280184, 0.290625, 0.297759, 0.302434, 0.31061, 0.320694, 0.330777, 0.340861, 0.349953, 0.350718, 0.351482, 0.352247, 0.353012, 0.352277, 0.350039, 0.3478, 0.345561, 0.343323, 0.338891, 0.333994, 0.329096, 0.324198, 0.319833, 0.321403, 0.322974, 0.324544, 0.326115, 0.321785, 0.317223, 0.312661, 0.3081, 0.30416, 0.300385, 0.296611, 0.292836, 0.289061, 0.285287, 0.281512, 0.277737, 0.273963, 0.271278, 0.269406, 0.267534, 0.263275, 0.257924, 0.252572, 0.247624, 0.242793, 0.237961, 0.233129, 0.228298, 0.223466, 0.220945, 0.218733, 0.216521, 0.216011, 0.215694, 0.215377, 0.21506, 0.214743, 0.214426, 0.213851, 0.210785, 0.20772, 0.204654, 0.201588, 0.198523, 0.195733, 0.193054, 0.190375, 0.187696, 0.185016, 0.182337, 0.179658, 0.177912, 0.176603, 0.175294, 0.173985, 0.172676, 0.171367, 0.170058, 0.168749, 0.168371, 0.168371, 0.168371, 0.168371, 0.168371, 0.168371, 0.168595, 0.169638, 0.17068, 0.171723, 0.172765, 0.173808, 0.17485, 0.176387, 0.178237, 0.180088, 0.181938, 0.183788, 0.185638, 0.188029, 0.190607, 0.193186, 0.195764, 0.198342, 0.20092, 0.203498, 0.206855, 0.21027, 0.213685, 0.2171, 0.220515, 0.22393, 0.227345, 0.23076, 0.234175, 0.23759, 0.241005, 0.24442, 0.247835, 0.25125, 0.255718, 0.260226, 0.264733, 0.269241, 0.273749, 0.278256, 0.282764, 0.287272, 0.29178,0.296287, 0.300795, 0.305195, 0.309307, 0.313419, 0.317531, 0.321643, 0.330389, 0.341227, 0.346927, 0.351669, 0.356411, 0.36123, 0.366574, 0.371918, 0.377262, 0.382606, 0.387949, 0.393111, 0.39809, 0.403068, 0.408046, 0.413024, 0.418003, 0.422584, 0.427064, 0.431544, 0.436023, 0.440503, 0.44422, 0.447931, 0.451641, 0.455351, 0.45888, 0.461254, 0.463629, 0.466003, 0.468378, 0.470752, 0.473263, 0.476195, 0.479127, 0.482059, 0.484991, 0.487924, 0.490856, 0.493788, 0.49672, 0.499652, 0.502697, 0.506066, 0.509435, 0.512804, 0.516173, 0.519542, 0.522926, 0.52639, 0.529853, 0.533317, 0.53678, 0.540243, 0.543707, 0.546372, 0.549037, 0.551701, 0.554366, 0.557031, 0.559696, 0.562361, 0.565026, 0.567277, 0.569313, 0.571349, 0.573385, 0.575421, 0.577457, 0.579493, 0.581529, 0.584508, 0.59192, 0.599333, 0.606746, 0.612583, 0.618351, 0.62412, 0.629888, 0.635656, 0.643897, 0.654147, 0.664398, 0.674648, 0.684898, 0.695148, 0.705398, 0.72041, 0.735472, 0.750534, 0.765595, 0.780312, 0.794769, 0.809226, 0.823684, 0.837698, 0.848234, 0.858771,0.869308, 0.879845, 0.890381, 0.900918, 0.911455, 0.921992, 0.932528, 0.943065, 0.953602, 0.964139, 0.974675, 0.985212, 0.995759, 1.00632, 1.01689, 1.02745, 1.03801, 1.04858, 1.05914, 1.0697, 1.08027, 1.09083, 1.10139, 1.11196, 1.12252, 1.13308, 1.14365, 1.15421, 1.1648, 1.17607, 1.18734, 1.19861, 1.20987, 1.22114, 1.23241, 1.24368, 1.25494, 1.26621, 1.27748, 1.28875, 1.30002, 1.31128, 1.32255, 1.33554, 1.34936, 1.36319, 1.37702, 1.39084, 1.40467, 1.4185, 1.43232, 1.44615, 1.45998, 1.4738, 1.48763, 1.50146, 1.51528};


//Xenon100 tables for upper bound on sigmaSI in pb. X coordinate is x=log(mass in GeV) starting from 1.9 and up to 6.9 in steps of 0.1. To obtain the mass you thus have to do exp(x)
const double Xenon100[54]={51,1.9,6.9,0.0008885359333968537,0.00008124604190417109,9.636140703641655e-6,2.6194771262659543e-6,9.43232482840263e-7,5.380701857724604e-7,2.0922717593267488e-7,1.1996386541455371e-7,6.847820034833743e-8,4.4246553040324174e-8,2.8907154306185405e-8,2.158151588453038e-8,1.8336600419081706e-8,1.5091684953633035e-8,1.1846769488184363e-8,8.601854022735689e-9,7.988762000207478e-9,7.407564852345493e-9,6.901814376857697e-9,6.999061193412319e-9,7.096308009966941e-9,7.21608840781437e-9,7.35823172350411e-9,7.822063605920217e-9,8.246027768528273e-9,8.73558747043288e-9,9.694552777087085e-9,9.984984157466596e-9,1.0950832991703643e-8,1.195350604512147e-8,1.2956179098539298e-8,1.3958852151957124e-8,1.4961525205374953e-8,1.596419825879278e-8,1.69882619370122e-8,1.926219372932326e-8,2.153612552163432e-8,2.3810057313945385e-8,2.6083989106256442e-8,2.8634954300906684e-8,3.119681015003516e-8,3.380278402858956e-8,3.688151964946632e-8,3.996025527034307e-8,4.3585472516131434e-8,4.734774909793015e-8,5.248557918007779e-8,5.924246510700267e-8,6.736725683840963e-8,7.371791672615601e-8,7.726059811925339e-8};


//LUX tables for upper bound exclusion line on sigmaSI in pb, at 90% C.L.. X coordinate is x=log(mass in GeV) starting from 1.7 and up to 8.5 in steps of 0.1. To obtain the mass you thus have to do exp(x). This data was taken from http://arxiv.org/pdf/1310.8214v1.pdf
const double LUX2013[72]={69,1.7,8.5,0.001646,7.667e-6,8.685e-7,2.24e-7,5.528e-8,2.354e-8,1.116e-8,6.392e-9,3.799e-9,2.841e-9,2.19e-9,1.72e-9,1.407e-9,1.179e-9,1.022e-9,9.323e-10,8.38e-10,8.001e-10,7.63e-10,7.719e-10,7.818e-10,7.927e-10,8.049e-10,8.491e-10,8.978e-10,9.517e-10,1.008e-9,1.075e-9,1.159e-9,1.251e-9,1.375e-9,1.514e-9,1.667e-9,1.836e-9,2.023e-9,2.227e-9,2.452e-9,2.701e-9,2.976e-9,3.275e-9,3.606e-9,3.959e-9,4.34e-9,4.76e-9,5.209e-9,5.704e-9,6.252e-9,6.845e-9,7.492e-9,8.207e-9,9.007e-9,9.941e-9,1.097e-8,1.212e-8,1.342e-8,1.495e-8,1.663e-8,1.847e-8,2.05e-8,2.279e-8,2.539e-8,2.827e-8,3.145e-8,3.497e-8,3.859e-8,4.261e-8,4.715e-8,5.219e-8,5.782e-8};

//Gfitter table with exlusion line from the process Z-> b bar at LEP. This gives the lower bound on tanbeta for a given mHcharged in the 2HDM at 95% C.L. X coordinate is x=mass in GeV starting from 15 and up to 700 in steps of 10.  This data was taken from http://gfitter.desy.de/Two_Higgs_Doublet_Model/2009_07_13_index.html
const double GfitterZbbar[72]={69,15,700,1.56134, 1.52955, 1.49801, 1.46735, 1.43658, 1.40396, 1.37117, 1.33876, 1.30697, 1.27539, 1.24649, 1.21789, 1.19005, 1.16282, 1.13559, 1.10977, 1.09025, 1.0708, 1.05134, 1.03197, 1.01265, 0.993336, 0.974018, 0.954699, 0.936787, 0.920462, 0.904137, 0.887812, 0.871487, 0.856272, 0.843516, 0.830759, 0.818002, 0.805362, 0.793024, 0.780744, 0.768465, 0.756385, 0.745265, 0.734759, 0.724444, 0.714666, 0.705232, 0.695919, 0.686786, 0.677653, 0.668519, 0.659386, 0.650282, 0.641205, 0.632131, 0.623057, 0.614701, 0.606975, 0.599548, 0.592431, 0.585551, 0.578867, 0.572428, 0.566652, 0.561464, 0.556276, 0.551089, 0.544777, 0.538163, 0.532419, 0.524921, 0.517309, 0.512273};

//CKMfitter table with exlusion line from the process Z-> b bar at LEP from taken from PRD82_073012. This gives the lower bound on tanbeta for a given mHcharged in the 2HDM at 95% C.L. X coordinate is x=mass in GeV starting from 15 and up to 1000 in steps of 10.  
const double CKMfitterZbbar[102]={99,15,1000,1.21823, 1.18652, 1.15875, 1.12674, 1.09065, 1.05912, 1.03417, 1.01303, 0.989157, 0.958602, 0.930948, 0.905483, 0.88241, 0.861557, 0.842595, 0.825002, 0.807994, 0.792119, 0.777339, 0.76322, 0.749298, 0.73526, 0.722095, 0.709641, 0.697801, 0.686698, 0.675801, 0.664029, 0.650339, 0.637354, 0.625086, 0.613466, 0.602379, 0.591825, 0.581806, 0.573139, 0.564749, 0.556629, 0.548977, 0.541489, 0.534362, 0.527466, 0.520789, 0.514322, 0.507944, 0.500857, 0.493745, 0.486936, 0.480353, 0.473924, 0.467811, 0.461776, 0.456046, 0.450391, 0.444942, 0.439605, 0.434452, 0.429422, 0.424555, 0.4198, 0.415203, 0.41069, 0.406349, 0.402047, 0.397948, 0.393848, 0.389941, 0.386048, 0.382288, 0.378606, 0.374975, 0.371497, 0.368019, 0.364693, 0.361408, 0.358167, 0.355064, 0.351961, 0.348962, 0.346031, 0.3431, 0.340307, 0.337532, 0.334727, 0.331562, 0.328397, 0.325337, 0.32233, 0.319351, 0.316494, 0.313637, 0.310871, 0.308156, 0.305444, 0.302865, 0.300286, 0.297748, 0.295297, 0.292847};


//Table with exlusion line from BBbar oscilations taken from PRD82_073012. This gives the lower bound on tanbeta for a given mHcharged in the 2HDM at 95% C.L. X coordinate is x=mass in GeV starting from 10 and up to 1000 in steps of 10.
const double DeltaMsDeltaMd[103]={100,10,1000,1.86789, 1.82007, 1.77057, 1.71721, 1.67192, 1.61506, 1.56847, 1.5292, 1.49531, 1.44906, 1.40564, 1.36711, 1.33261, 1.30143, 1.26798, 1.23672, 1.20804, 1.18161, 1.15716, 1.13385, 1.11179, 1.09116, 1.07183, 1.05364, 1.03647, 1.02021, 1.00246, 0.985158, 0.968715, 0.953126, 0.938261, 0.924115, 0.910561, 0.897654, 0.885287, 0.873417, 0.862017, 0.851063, 0.840449, 0.828947, 0.817829, 0.807117, 0.796789, 0.786823, 0.7772, 0.767898, 0.758897, 0.750185, 0.741788, 0.73365, 0.725764, 0.718105, 0.710669, 0.703497, 0.696497, 0.68965, 0.683064, 0.676623, 0.670306, 0.664239, 0.65826, 0.65246, 0.646802, 0.641249, 0.635883, 0.63057, 0.625467, 0.620388, 0.615519, 0.610668, 0.605717, 0.600751, 0.595588, 0.59039, 0.585396, 0.580419, 0.575639, 0.570877, 0.566286, 0.561734, 0.557308, 0.55296, 0.548675, 0.544525, 0.540375, 0.5364, 0.532442, 0.528806, 0.525688, 0.522571, 0.519533, 0.516871, 0.514209, 0.511548, 0.508952, 0.506446, 0.503941, 0.501436,0.49893, 0.496425};

#endif
